#include<stdio.h>          // ARITHMETIC: +, -, *, /, %

unsigned long plus( unsigned long c, unsigned long d)
{	unsigned long e;
	while ( d ) {
		e = c ^ d;
		d = c & d;
		d <<= 1;
		c = e;
	}
	return c;
}

unsigned long minus( unsigned long c, unsigned long d)
{
	d = ~d;
	d = plus( d, 1);
	return plus(c, d);
}

unsigned long multiply( unsigned long c, unsigned long d)
{
	unsigned long e = 1, f = 0, g = c, h = 0xffffffff;
	while( d & h) 	{
		if ( d & e)
			f = plus ( f, g );
		e <<= 1;
		g <<= 1;
		h <<= 1;
	}
	return f;
}

unsigned long divide( unsigned long c, unsigned long d)
{
	unsigned long e = 0x4000000, f = d, target = 0;

	while ( !(c & e) )    e >>= 1;
	while ( !(f & e) )    f <<= 1;

	while ( ! ( minus( f, d ) & 0x8000000 ) ) 	{
		target <<= 1;
		if ( c >= f)  {
			c = minus( c, f);
			target = target | 1 ;
		}
		f >>= 1;
	}
	return target;
}

unsigned long remainder ( unsigned long c, unsigned long d )
{
	unsigned long temp = divide ( c , d );
	return c - multiply ( temp , d );
}

void main()
{	unsigned long a, b, result;
	char sign;
	puts("PUT NUMBERS AND OPERATOR    <  a  +  b  >");
	scanf("%lu %c %lu", & a, & sign, & b );

	switch (sign) {
		case '+' : result = plus ( a, b );        break;
		case '-' : result = minus ( a, b );       break;
		case '*' : result = multiply ( a, b );    break;
		case '/' : result = divide ( a, b );      break;
		case '%' : result = remainder ( a, b );
	}
	printf ("\n%lu %c %lu = %lu\n", a, sign, b, result );
}

