// MinkowskiView.cpp : implementation of the CMinkowskiView class
//

#include "stdafx.h"
#include "Minkowski.h"

#include "MinkowskiDoc.h"
#include "MinkowskiView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMinkowskiView

IMPLEMENT_DYNCREATE(CMinkowskiView, CView)

BEGIN_MESSAGE_MAP(CMinkowskiView, CView)
	//{{AFX_MSG_MAP(CMinkowskiView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMinkowskiView construction/destruction

CMinkowskiView::CMinkowskiView()
{
	// TODO: add construction code here

}

CMinkowskiView::~CMinkowskiView()
{
}

BOOL CMinkowskiView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMinkowskiView drawing

void CMinkowskiView::OnDraw(CDC* pDC)
{	int n = 5;
	int xA = 0, yA = 100 , xB = 600 , yB = 100 ;
	Minkowski (pDC , xA , yA , xB , yB , n );
}


#define MODEL 4
double xx [ MODEL ] = { .45, .5, .55 , 1 }, yy [ MODEL ] = { 0, 0.45, 0, 0 };

// #define MODEL 8
// double xx [ MODEL ] = { .25, .25, .5, .5, .5,  .75, .75, 1 },
//        yy [ MODEL ] = { 0,   .25, .25, 0, -.25, -.25, 0, 0 };


void CMinkowskiView::Minkowski ( CDC * pDC , double xA, double yA, double xB, double yB, int n )
{
	double  x, y, x1 = xA, y1 = yA, dX = xB - xA, dY = yB - yA;
	if ( n == 0 ) {
		pDC -> MoveTo ( xA, yA );
		pDC -> LineTo ( xB, yB );
		return ;
	}

	for ( int i = 0; i < MODEL; i++ ) {
		x = x1;   y = y1;
		x1 = xA + dX * xx [ i ] - dY * yy [ i ];
		y1 = yA + dY * xx [ i ] + dX * yy [ i ];
		Minkowski ( pDC , x, y, x1, y1, n - 1 );
	}
}


/////////////////////////////////////////////////////////////////////////////
// CMinkowskiView diagnostics

#ifdef _DEBUG
void CMinkowskiView::AssertValid() const
{
	CView::AssertValid();
}

void CMinkowskiView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMinkowskiDoc* CMinkowskiView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMinkowskiDoc)));
	return (CMinkowskiDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMinkowskiView message handlers
