#include <stdio.h>
#include <stdlib.h>

int ** matrixAllocat_Init ( unsigned size , int * data )
{
	int ** ppMatr ;
	unsigned i , j ;

	ppMatr = ( int ** ) malloc ( sizeof ( int * ) * size );
	for ( i = 0 ; i < size ; i ++ )
		ppMatr [ i ] = ( int * ) malloc ( sizeof ( int ) * ( size - i )) ;

	for ( i = 0 ; i < size ; i++ )
		for ( j = 0 ; j < size - i ; j ++ )
			if ( * data )
				ppMatr [ i ][ j ] = * data ++ ;
			else
				ppMatr [ i ][ j ] = 0;
	return ppMatr ;
}

void matrixPrint ( int ** ppMatr , unsigned  size )
{       unsigned i, j;
	for ( i = 0 ; i < size ; i++ ) {
		for ( j = 0 ; j < size - i ; j++ )
			printf ( "%4d",   ppMatr [ i ] [ j ] );
		printf ("\n");
	}
}

void matrixDelete ( int ** ppMatr , unsigned size )
{       unsigned i;
	for ( i = 0 ; i < size ; i++ )
		free ( ppMatr [ i ] ) ;
	free ( ppMatr ) ;
}

void main ()
{
	int ** ppA , **ppB ;
	unsigned sizeA = 4 , sizeB = 3 ;
	int dataA [] = { 1, 2, 3, 4, 5, 6,  7, 8, 9, 10 };

	ppA = matrixAllocat_Init ( sizeA, dataA );
	ppB = matrixAllocat_Init ( sizeB, NULL );

	matrixPrint ( ppA , sizeA );
	matrixPrint ( ppB , sizeB );

	matrixDelete ( ppA , sizeA );
	matrixDelete ( ppB , sizeB );
}
