#include <stdio.h>
#include <math.h>

#define N 8

enum TYPE { LONG , DOUBLE , FRACTION , DEC_FRACTION } ;

struct Element {
	TYPE  elementType ;
	void * pElem ;
} ;

struct Fraction {
	short num , denom ;
} ;
struct DecFraction {
	short num , power ;
} ;

float toFloat ( Element myElement )
{
      switch ( myElement . elementType ) {
		case LONG :
			return	( float ) * ( long * ) myElement.pElem ;
		case DOUBLE :
			return * ( double * ) myElement.pElem ;
		case FRACTION :
			return 	( float ) ( ( Fraction * ) myElement.pElem ) -> num
				/ ( ( Fraction * ) myElement.pElem ) -> denom ;
		case DEC_FRACTION :
			return ( ( DecFraction * ) myElement.pElem ) -> num
				/ pow10 ( ( ( Fraction * ) myElement.pElem ) -> denom )  ;
	}
}

void printElement ( Element myElement )
{
      switch ( myElement . elementType ) {
		case LONG :
			printf ( "Type LONG : %ld   " ,
				* ( long * ) myElement.pElem );
			break ;
		case DOUBLE :
			printf ( "Type DOUBLE : %f   " ,
				* ( double * ) myElement.pElem );
			break ;
		case FRACTION :
			printf ( "Type FRACTION : %d / %d  " ,
				( ( Fraction * ) myElement.pElem ) -> num ,
				( ( Fraction * ) myElement.pElem ) -> denom );
			break ;
		case DEC_FRACTION :
			printf ( "Type DEC_FRACTION : %d / 10^%d  " ,
				( ( DecFraction * ) myElement.pElem ) -> num ,
				( ( DecFraction * ) myElement.pElem ) -> power );
	}
	printf (" ( float form %f )\n" , toFloat ( myElement ) );
}

void main ( )
{
	// Initial objects
	long a = 12 , b = - 345 ;
	double c = 67.89 , d = .0123 ;
	Fraction e = { 456 , 78 } , f = { - 9 , 123 } ;
	DecFraction g = { 456 , 2 } , h = { - 78 , 1 } ;
	short i , j ;

	Element arrElem [ N ] = {
		{ LONG , & a } ,
		{ LONG , & b } ,
		{ DOUBLE , & c } ,
		{ DOUBLE , & d } ,
		{ FRACTION , & e } ,
		{ FRACTION , & f } ,
		{ DEC_FRACTION , & g } ,
		{ DEC_FRACTION , & h }
	};

	Element tempElem ;

	for ( i = 0 ; i < N ; i ++ )
		printElement ( arrElem [ i ] );

	for ( i = 0 ; i < N - 1 ; i ++ )
		for ( j = N - 2 ; j >= i ; j -- )
			if ( toFloat ( arrElem [ j ] ) > toFloat ( arrElem [ j + 1 ] ) )
			{
				tempElem = arrElem [ j ] ;
				arrElem [ j ] = arrElem [ j + 1 ] ;
				arrElem [ j + 1 ] = tempElem ;
			}

	printf ( "\n\n After sorting:\n" );
	for ( i = 0 ; i < N ; i ++ )
		printElement ( arrElem [ i ] );
}