#include <stdio.h>
#include <math.h>

#define N 5

int isEqual_Char ( void * a , void * b )
{
	return  * ( char * ) a == * ( char * ) b ;
}
int isEqual_Int ( void * a , void * b )
{
	return  * ( int * ) a == * ( int * ) b ;
}
int isEqual_Float ( void * a , void * b )
{
	return  fabs ( * ( float * ) a - * ( float * ) b ) < .0001 ;
}

int linearSearch ( void * pArray , void * pSearchElement , unsigned nElements,
	unsigned sizeElement , int ( * isEqual )( void * , void * ) )
{
	unsigned i ;
	for ( i = 0 ; i < nElements ; i ++ ) {
		if ( isEqual ( pArray , pSearchElement ) )
			return  i;
		pArray = ( char * ) pArray + sizeElement ;
	}
	return - 1;
}

void main ( )
{
	int arrayInt [ N ] =  { 123 , 3, 45, 789, 78 } , searchInt = 789 , i , result ;
	char arrayChar [ N ] = { 'w' , 'A' , 'e' , 'b' , 'Q' } , searchChar = 'Z' ;
	float arrayFloat [ N ] =  { 1.23 , 3, 45., 7.89, .78 } , searchFloat = .78 ;

	result = linearSearch ( arrayInt , & searchInt , N , sizeof ( int ) ,isEqual_Int );
	if ( result >= 0 )
		printf ( "%d  found in %d place \n" , searchInt , result );
	else
		printf ( "%d  not found \n" , searchInt );

	result = linearSearch ( arrayChar , & searchChar , N , sizeof ( char ) ,isEqual_Char );
	if ( result >= 0 )
		printf ( "%c  found in %d place \n" , searchChar , result );
	else
		printf ( "%c  not found \n" , searchChar );

	result = linearSearch ( arrayFloat , & searchFloat , N , sizeof ( float ) ,isEqual_Float );
	if ( result >= 0 )
		printf ( "%f  found in %d place \n" , searchFloat , result );
	else
		printf ( "%f  not found \n" , searchFloat );
}