#include <stdio.h>
#include <math.h>

#define N 8
//----------------------------
typedef struct  {
	void * pElem ;
	double ( * pToDouble ) ( void * ) ;
	void ( * pPrint ) ( void * ) ;
} Element;

double LongToDouble ( void * arg )
{	return ( double ) * ( long * ) arg ;
}
void LongPrint ( void * arg )
{	printf ( "\nLong type  %ld   \t\t ( float form %f )" ,
	       * ( long * ) arg , LongToDouble ( arg ) );
}
//---------------------------- 
double DoubleToDouble ( void * arg )
{	return * ( double * ) arg ;
}
void DoublePrint ( void * arg )
{	printf ( "\n \t\t\t\t Float type  %f " ,  * ( double * ) arg );
}
//---------------------------- 
typedef struct  {
	int num , denom ;
} Fraction;

double FractionToDouble ( void * arg )
{	return ( double ) ( ( Fraction * ) arg ) -> num /  ( ( Fraction * ) arg ) -> denom ;
}
void FractionPrint ( void * arg )
{	printf ( "\nFraction type  %d / %d \t ( float form %f )" ,
	       ( ( Fraction * ) arg ) -> num , ( ( Fraction * ) arg ) -> denom ,
	       FractionToDouble ( arg ) );
}
//----------------------------
typedef struct {
	int num , power ;
} DecFraction ;
double DecFractionToDouble ( void * arg )
{
	return ( ( DecFraction * ) arg ) -> num / pow ( ( ( DecFraction * ) arg ) -> power , 10 );
}
void DecFractionPrint ( void * arg )
{
	printf ( "\nDecFraction type  %d / 10^%d \t ( float form %f )" ,
	       ( ( DecFraction * ) arg ) -> num , ( ( DecFraction * ) arg ) -> power ,
	       DecFractionToDouble ( arg ) );
}
//----------------------------
void main ( )
{
	long a = 12 , b = - 345, i, j ;
	double c = 67.89 , d = .0123 ;
	Fraction e = { 456 , 78 } , f = { - 9 , 123 } ;
	DecFraction g = { 456 , 2 } , h = { - 78 , 1 } ;

	Element arrElem [ N ] = {
		{ & a , LongToDouble , LongPrint } ,
		{ & b , LongToDouble , LongPrint } ,
		{ & c , DoubleToDouble , DoublePrint } ,
		{ & d , DoubleToDouble , DoublePrint } ,
		{ & e , FractionToDouble , FractionPrint } ,
		{ & f , FractionToDouble , FractionPrint } ,
		{ & g , DecFractionToDouble , DecFractionPrint } ,
		{ & h , DecFractionToDouble , DecFractionPrint }
	};
	Element tempElem ;

	for ( i = 0 ; i < N ; i ++ )
		arrElem [ i ] . pPrint ( arrElem [ i ] . pElem ) ;

	for ( i = 0 ; i < N - 1 ; i ++ )
		for ( j = N - 2 ; j >= i ; j -- )
			if ( arrElem [ j ] . pToDouble ( arrElem [ j ] . pElem )
			  >  arrElem [ j + 1 ] . pToDouble ( arrElem [ j + 1 ] . pElem ) )
			{
				tempElem = arrElem [ j ] ;
				arrElem [ j ] = arrElem [ j + 1 ] ;
				arrElem [ j + 1 ] = tempElem ;
			}

	printf ( "\n\n After sorting:\n" );
	for ( i = 0 ; i < N ; i ++ )
		arrElem [ i ] . pPrint ( arrElem [ i ] . pElem ) ;
}