// FanView.cpp : implementation of the CFanView class
//

#include "stdafx.h"
#include "Fan.h"

#include "FanDoc.h"
#include "FanView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFanView

IMPLEMENT_DYNCREATE(CFanView, CView)

BEGIN_MESSAGE_MAP(CFanView, CView)
	//{{AFX_MSG_MAP(CFanView)
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFanView construction/destruction

CFanView::CFanView () 
{
	 lastRed = signRed = lastGreen = 0;
	 signGreen = 3; 
	 lastBlue = 255;
	 signBlue = -3;
	 indexLast = counterColor = 0;
	 indexFirst = NUM_LINES - 1 ;
	 for ( int i = 0 ; i < NUM_LINES - 1 ; i ++ ) 
			arrLefts [ i ] = arrRights [ i ] = CPoint ( 0, 0 );
	arrLefts [ NUM_LINES - 1 ] = CPoint ( 30 , 100 );
	arrRights [ NUM_LINES - 1 ] = CPoint ( 60 , 150 );
	VelocityLeftX = 6; VelocityLeftY = 8, 
	VelocityRightX = 5; VelocityRightY = 9;
}

CFanView::~CFanView()
{
}

BOOL CFanView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CFanView drawing

void CFanView::OnDraw(CDC* pDC)
{
	CRect rect ;
	GetClientRect ( & rect );
	pDC -> PatBlt ( 0 , 0 , rect.Width () , rect.Height (), R2_BLACK )  ;

	int _lastRed = lastRed , _lastGreen = lastGreen , _lastBlue = lastBlue ,
		_signRed = signRed , _signGreen = signGreen, 
		_signBlue = signBlue , _counterColor = counterColor ;
	int index = indexFirst ;

	do {
		CPen lastPen ( PS_SOLID , 1 , RGB ( _lastRed, _lastGreen , _lastBlue ) ) ;
		pDC -> SelectObject ( & lastPen );
		pDC -> MoveTo ( arrLefts [ index ] );
		pDC -> LineTo ( arrRights [ index ] );

		_lastRed -= _signRed;   _lastGreen -= _signGreen;   _lastBlue -= _signBlue;
		if ( -- _counterColor == - 1 ) {    				 			// 85 = 255 / 3
			_counterColor = 85;
			char temp = _signBlue;
			_signBlue = _signGreen;    _signGreen = _signRed;  	_signRed = temp;
		}
		index -- ;
		if ( index == 0 )
				index = NUM_LINES - 1 ;
	}
	while ( index != indexFirst );

}

/////////////////////////////////////////////////////////////////////////////
// CFanView diagnostics

#ifdef _DEBUG
void CFanView::AssertValid() const
{
	CView::AssertValid();
}

void CFanView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CFanDoc* CFanView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFanDoc)));
	return (CFanDoc*)m_pDocument;
}
#endif //_DEBUG

void CFanView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CClientDC dc ( this ) ;

	dc.SelectStockObject ( BLACK_PEN );
	dc . MoveTo ( arrLefts [ indexLast ] );
	dc . LineTo ( arrRights [ indexLast ] );

	CRect rect ;
	GetClientRect ( & rect );

	if ( ! rect.PtInRect ( arrLefts [ indexFirst ] + CSize ( VelocityLeftX , 0) ) )
		VelocityLeftX =  - VelocityLeftX ;
	if ( ! rect.PtInRect ( arrLefts [ indexFirst ] + CSize ( 0 , VelocityLeftY ) ) )
		VelocityLeftY =  - VelocityLeftY ;

	if ( ! rect.PtInRect ( arrRights [ indexFirst ] + CSize ( VelocityRightX , 0) ) )
		VelocityRightX =  - VelocityRightX ;
	if ( ! rect.PtInRect ( arrRights [ indexFirst ] + CSize ( 0 , VelocityRightY ) ) )
		VelocityRightY =  - VelocityRightY ;
	
	arrLefts [ indexLast ] = arrLefts [ indexFirst ] + CSize ( VelocityLeftX , VelocityLeftY) ; 
	arrRights [ indexLast ] = arrRights [ indexFirst ] + CSize ( VelocityRightX , VelocityRightY) ; 

	CPen lastPen ( PS_SOLID , 1 , RGB ( lastRed, lastGreen ,lastBlue ) ) ;
	dc.SelectObject ( & lastPen );
	dc . MoveTo ( arrLefts [ indexLast ] );
	dc . LineTo ( arrRights [ indexLast ] );

	indexLast = ( indexLast + 1 ) % NUM_LINES ;
	indexFirst = ( indexFirst + 1 ) % NUM_LINES ;

	lastRed += signRed;   lastGreen += signGreen;   lastBlue += signBlue;
	if ( ++ counterColor == 85 ) {    				 			// 85 = 255 / 3
		counterColor = 0;
		char temp = signRed;
		signRed = signGreen;    signGreen = signBlue;  	signBlue = temp;
	}

	CView::OnTimer(nIDEvent);
}

int CFanView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	SetTimer ( 1 , 50 , 0 ) ;
	// TODO: Add your specialized creation code here
	
	return 0;
}

void CFanView::OnDestroy() 
{
	CView::OnDestroy();
	KillTimer ( 1 );
	// TODO: Add your message handler code here
	
}
