#include <graphics.h>
#include <stdlib.h>
#include <bios.h>
#include <dos.h>

					// MOTION REGION :
					// 20 < x < 620, 15 < y < 335

#define NODES 4
#define N 15                  // INTERNAL POINTS BETWEEN NODES

struct XY {
	int x, y;
	char xSign, ySign;
};

void waitRay ( void )
{
asm 	 mov dx,0x3da
l:
asm {    in al, dx
	 and al, 0x08
	 jz  l
    }
}

void loadArray ( struct XY * arr )
{
	int xCoeff = 300 / NODES, yCoeff = 300 / NODES, i;
	for ( i = 0; i < 2 * NODES ; i++ ) {
		arr [ i ] . x = 20 + i * xCoeff;
		arr [ i ] . y = 15 + random ( 200 );
		arr [ i ] . xSign = - 1 + 2 * random ( 2 );
		arr [ i ] . ySign = - 1 + 2 * random ( 2 );
		arr [ i + 3 * NODES ] . x = 620 - i * xCoeff;
		arr [ i + 3 * NODES ] . y = 335 - random ( 200 );
		arr [ i + 3 * NODES ] . xSign = - 1 + 2 * random ( 2 );
		arr [ i + 3 * NODES ] . ySign = - 1 + 2 * random ( 2 );
	}
	for ( i = 0; i < NODES ; i++ ) {
		arr [ i + 2 * NODES ] . x = 620 - random ( 200 );
		arr [ i + 2 * NODES ] . y = 15 + i * yCoeff;
		arr [ i + 2 * NODES ] . xSign = - 1 + 2 * random ( 2 );
		arr [ i + 2 * NODES ] . ySign = - 1 + 2 * random ( 2 );
		arr [ i + 5 * NODES ] . x = 20 + random ( 200 );
		arr [ i + 5 * NODES ] . y = 335 - i * yCoeff;
		arr [ i + 5 * NODES ] . xSign = - 1 + 2 * random ( 2 );
		arr [ i + 5 * NODES ] . ySign = - 1 + 2 * random ( 2 );
	}
}

void main()
{
  float  t, a0, a1, a2, a3, b0, b1, b2, b3;
  int driver = VGA, mode = VGAMED, arrSize = 6 * NODES + 3, i, j, first = 1,
	xx, yy, scr1 = 0, scr2 = 1, temp, control;
  char R = 63, G = 0, B = 0, count = 0, signR = -1, signG = 0, signB = 1;
  struct palettetype pal;
  struct XY arr [ 6 * NODES + 3 ];

  loadArray ( arr );
  initgraph( &driver, &mode, "d:\\my_bc\\bgi");
  getpalette(&pal);
  setrgbpalette ( pal.colors [ 1 ], R, G, B );
  setcolor ( 1 );
   while ( ! bioskey ( 1 ) )
   {
	for ( i = 0; i < arrSize - 3; i ++ ) {
	    temp = 2 + random ( 5 );
	    control = arr [ i ] . x  + arr [ i ] . xSign * temp;
	    if ( control > 620 || control < 20 )
		arr [ i ] . xSign *= -1;
	    arr [ i ] . x += temp * arr [ i ] . xSign;

	    temp = 2 + random ( 5 );
	    control = arr [ i ] . y  + arr [ i ] . ySign * temp;
	    if ( control > 335 || control < 15 )
		arr [ i ] . ySign *= -1;
	    arr [ i ] . y += temp * arr [ i ] . ySign;
	}
	arr [ arrSize - 3 ] . x = arr [ 0 ] . x;
	arr [ arrSize - 3 ] . y = arr [ 0 ] . y;
	arr [ arrSize - 2 ] . x = arr [ 1 ] . x;
	arr [ arrSize - 2 ] . y = arr [ 1 ] . y;
	arr [ arrSize - 1 ] . x = arr [ 2 ] . x;
	arr [ arrSize - 1 ] . y = arr [ 2 ] . y;

	setvisualpage ( scr1 );
	setactivepage ( scr2 );
	waitRay();
	cleardevice();

	for ( i = 1; i < arrSize - 2; i++)   {
	 a3 = ( -arr[i-1].x + 3 * (arr[i].x - arr[i+1].x) + arr[i+2].x ) / 6.0;
	 b3 = ( -arr[i-1].y + 3 * (arr[i].y - arr[i+1].y) + arr[i+2].y ) / 6.0;
	 a2 = ( arr[i-1].x - 2 * arr[i].x + arr[i+1].x ) / 2.0;
	 b2 = ( arr[i-1].y - 2 * arr[i].y + arr[i+1].y ) / 2.0;
	 a1 = ( arr[i+1].x - arr[i-1].x ) / 2.0;
	 b1 = ( arr[i+1].y - arr[i-1].y ) / 2.0;
	 a0 = ( arr[i-1].x + 4 * arr[i].x + arr[i+1].x ) /6.0;
	 b0 = ( arr[i-1].y + 4 * arr[i].y + arr[i+1].y ) /6.0;

	 for ( j = 0; j <= N; j++)  {
		t = (float) j / N;
		xx = (( a3 * t + a2 ) * t + a1 ) * t + a0 ;
		yy = (( b3 * t + b2 ) * t + b1 ) * t + b0 ;
		if ( first ) {
			 first = 0;
			 moveto(xx, yy);
		}  else lineto(xx, yy);
	 }
	}
	temp = scr1;
	scr1 = scr2;
	scr2 = temp;
	first = 1;

	R += signR;
	G += signG;
	B += signB;
	count ++ ;
	if ( count == 63 ) {
		count = 0;
		temp = signR;
		signR = signG;
		signG = signB;
		signB = temp;
	}
	setrgbpalette ( pal.colors [ 1 ], R, G, B );

	delay ( 40 );
    }
}