// SplinSServView.cpp : implementation of the CSplinSServView class
//

#include "stdafx.h"
#include "SplinSServ.h"

#include "SplinSServDoc.h"
#include "SplinSServView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSplinSServView

IMPLEMENT_DYNCREATE(CSplinSServView, CView)

BEGIN_MESSAGE_MAP(CSplinSServView, CView)
	//{{AFX_MSG_MAP(CSplinSServView)
	ON_WM_CREATE()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSplinSServView construction/destruction

CSplinSServView::CSplinSServView()
{
	// TODO: add construction code here
	 lastRed = signRed = lastGreen = 0;
	 signGreen = 3; 
	 lastBlue = 255;
	 signBlue = -3;
	 counterColor = 0;
}

CSplinSServView::~CSplinSServView()
{
}

BOOL CSplinSServView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSplinSServView drawing

void CSplinSServView::OnDraw(CDC* pDC)
{
	CSplinSServDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
}

/////////////////////////////////////////////////////////////////////////////
// CSplinSServView diagnostics

#ifdef _DEBUG
void CSplinSServView::AssertValid() const
{
	CView::AssertValid();
}

void CSplinSServView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSplinSServDoc* CSplinSServView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSplinSServDoc)));
	return (CSplinSServDoc*)m_pDocument;
}
#endif //_DEBUG

int CSplinSServView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	CRect rect ;
	GetClientRect ( & rect );
	
	CPoint pointTopLeft = CPoint ( 250 , 150 ) , 
		   pointBottomRight	= pointTopLeft + rect.Size ()  ; 
	int xCoeff = 100 / NODES, yCoeff = 100 / NODES, i;
	for ( i = 0; i < 2 * NODES ; i++ ) {
		arrPoints [ i ] . x = pointTopLeft.x + i * xCoeff;
		arrPoints [ i ] . y = pointTopLeft.y + rand()%200 ;
		arrSign [ i ] . xSign = - 1 + 2 * rand()%2;
		arrSign [ i ] . ySign = - 1 + 2 * rand()%2;
		arrPoints [ i + 3 * NODES ] . x = pointBottomRight.x - i * xCoeff;
		arrPoints [ i + 3 * NODES ] . y = pointBottomRight.y - rand()%200 ;
		arrSign [ i + 3 * NODES ] . xSign = - 1 + 2 * rand()%2;
		arrSign [ i + 3 * NODES ] . ySign = - 1 + 2 * rand()%2;
	}
	for ( i = 0; i < NODES ; i++ ) {
		arrPoints [ i + 2 * NODES ] . x = pointBottomRight.x - rand()%200 ;
		arrPoints [ i + 2 * NODES ] . y = pointTopLeft.y + i * yCoeff;
		arrSign [ i + 2 * NODES ] . xSign = - 1 + 2 * rand()%2;
		arrSign [ i + 2 * NODES ] . ySign = - 1 + 2 * rand()%2;
		arrPoints [ i + 5 * NODES ] . x = pointTopLeft.x + rand()%200 ;
		arrPoints [ i + 5 * NODES ] . y = pointBottomRight.y - i * yCoeff;
		arrSign [ i + 5 * NODES ] . xSign = - 1 + 2 * rand()%2;
		arrSign [ i + 5 * NODES ] . ySign = - 1 + 2 * rand()%2;
	}


	// TODO: Add your specialized creation code here
	SetTimer ( 1 , 50 , 0 ) ;

	return 0;
}

void CSplinSServView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CClientDC dc ( this ) ;

	CRect rect ;
	GetClientRect ( & rect );
	dc . PatBlt ( 0 , 0 , rect.Width () , rect.Height (), R2_BLACK )  ;

	CPoint pointTopLeft = CPoint ( 0 , 0 ) , 
		   pointBottomRight	= pointTopLeft + rect.Size () ; 
	
	CPen lastPen ( PS_SOLID , 1 , RGB ( lastRed, lastGreen ,lastBlue ) ) ;
	dc.SelectObject ( & lastPen );

	lastRed += signRed;   lastGreen += signGreen;   lastBlue += signBlue;
	if ( ++ counterColor == 85 ) {    				 			// 85 = 255 / 3
		counterColor = 0;
		char temp = signRed;
		signRed = signGreen;    signGreen = signBlue;  	signBlue = temp;
	}
	
	for ( int i = 0; i < arrSize - 4; i ++ ) {     ////-3
	    int temp = 2 + rand()%5 ;
	    int control = arrPoints [ i ] . x  + arrSign [ i ] . xSign * temp;
	    if ( control > pointBottomRight.x || control < pointTopLeft.x )
		arrSign [ i ] . xSign *= -1;
	    arrPoints [ i ] . x += temp * arrSign [ i ] . xSign;

	    temp = 2 + rand()%5 ;
	    control = arrPoints [ i ] . y  + arrSign [ i ] . ySign * temp;
	    if ( control > pointBottomRight.y || control < pointTopLeft.y )
		arrSign [ i ] . ySign *= -1;
	    arrPoints [ i ] . y += temp * arrSign [ i ] . ySign;
	}

	arrPoints [ arrSize - 4 ] = arrPoints [ 0 ] ;
	arrPoints [ arrSize - 3 ] = arrPoints [ 1 ] ;
	arrPoints [ arrSize - 2 ] = arrPoints [ 2 ] ;
	arrPoints [ arrSize - 1 ] = arrPoints [ 3 ] ;
	

//	dc.Polyline ( arrPoints , arrSize );
	dc.PolyBezier ( arrPoints , arrSize );
	CView::OnTimer(nIDEvent);
}

void CSplinSServView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: Add your message handler code here
	KillTimer ( 1 );
}
