// MoveView.cpp : implementation of the CMoveView class
//

#include "stdafx.h"
#include "Move.h"

#include "MoveDoc.h"
#include "MoveView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMoveView

IMPLEMENT_DYNCREATE(CMoveView, CView)

BEGIN_MESSAGE_MAP(CMoveView, CView)
	//{{AFX_MSG_MAP(CMoveView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMoveView construction/destruction

CMoveView::CMoveView()
{
	LeftTopPoint = CPoint ( 0, 0 );
	rectSize = CSize ( 427 , 212 );
	flag = FALSE ;
	// TODO: add construction code here

}

CMoveView::~CMoveView()
{
}

BOOL CMoveView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
////////------------------------------
   hBalloonsBmp = (HBITMAP)::LoadImage(cs.hInstance, 
      MAKEINTRESOURCE(IDB_BALLOONS), IMAGE_BITMAP, 
      0, 0, LR_DEFAULTCOLOR);  // actual size
  hPositiveBmp = (HBITMAP)::LoadImage(cs.hInstance, 
      MAKEINTRESOURCE(IDB_POSITIVE), IMAGE_BITMAP, 
      0, 0, LR_DEFAULTCOLOR);  // actual size  
  hNegativeBmp = (HBITMAP)::LoadImage(cs.hInstance, 
      MAKEINTRESOURCE(IDB_NEGATIVE), IMAGE_BITMAP, 
      0, 0, LR_DEFAULTCOLOR);  // actual size
//////-----------------------------------

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMoveView drawing

void CMoveView::OnDraw(CDC* pDC)
{
	CRect rect ;
	GetClientRect ( & rect );
	CDC   dcMem;
   
    dcMem.CreateCompatibleDC(pDC);

	dcMem . SelectObject( hBalloonsBmp);
	pDC ->BitBlt(rect.left, rect.top, rect.right, rect.bottom, 
                   &dcMem, 0, 0, SRCCOPY);

	dcMem . SelectObject( hNegativeBmp);
	pDC ->BitBlt(rect.left, rect.top, rect.right, rect.bottom, 
                   &dcMem, 0, 0, SRCAND); 

	dcMem . SelectObject( hPositiveBmp);
	pDC ->BitBlt(rect.left, rect.top, rect.right, rect.bottom, 
                   &dcMem, 0, 0, SRCPAINT); 
}

/////////////////////////////////////////////////////////////////////////////
// CMoveView diagnostics

#ifdef _DEBUG
void CMoveView::AssertValid() const
{
	CView::AssertValid();
}

void CMoveView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMoveDoc* CMoveView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMoveDoc)));
	return (CMoveDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMoveView message handlers

void CMoveView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if ( flag == FALSE &&
		CRect (  LeftTopPoint , rectSize ) . PtInRect ( point ) ) {
			flag = TRUE ;
			deltaMouseTopLeft = 
				CSize ( point - LeftTopPoint );
	}

	CView::OnLButtonDown(nFlags, point);
}

void CMoveView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	flag = FALSE ;

	CView::OnLButtonUp(nFlags, point);
}


void waitRay ()
{
_asm 	 mov dx,0x3da
l:
_asm {    in al, dx
	 and al, 0x08
	 jz  l
    }
}

void CMoveView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if ( flag == TRUE ) {

	CClientDC dc ( this );
	CDC   dcMem;
    dcMem.CreateCompatibleDC(&dc);


	waitRay();
	dcMem . SelectObject( hBalloonsBmp);
	dc.BitBlt( LeftTopPoint.x ,LeftTopPoint.y , 
		rectSize.cx , rectSize.cy , &dcMem, 
		LeftTopPoint.x ,LeftTopPoint.y , SRCCOPY);

	LeftTopPoint = point - deltaMouseTopLeft ;

	dcMem . SelectObject( hNegativeBmp);
	dc.BitBlt( LeftTopPoint.x ,LeftTopPoint.y ,
		rectSize.cx , rectSize.cy , &dcMem ,
		0, 0, SRCAND); 

	dcMem . SelectObject( hPositiveBmp);
	dc.BitBlt( LeftTopPoint.x ,LeftTopPoint.y ,
		rectSize.cx , rectSize.cy , & dcMem ,
		0, 0, SRCPAINT); 
	}
	CView::OnMouseMove(nFlags, point);
}

void CMoveView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	Invalidate ();
	LeftTopPoint = CPoint ( 0 , 0 );
	// TODO: Add your message handler code here
	
}
