#include <graphics.h>                     // 3D SURFACE 
#include <stdlib.h>                       // FLOAT  HORIZON  METHOD
#include <math.h>

#define YMAX 479
#define SIGN(x) ( x ) > 0 ? 1 : ( x ) == 0 ? 0 : -1

float function ( float x, float z)
{
       float xx = x - 320, zz = z - 320;
       float a = (xx * xx + zz * zz) / 10000 ;

//	return  ( sqrt ( a + 20 ) - sqrt ( a ) ) * 100 ;

//	return ( a * a - 1 ) / ( 1 + a * a * a * a) * 200 + 300;

//	return   ( a + 1 ) / ( 1 + ( a + 1 ) * ( a + 1 ) ) * 300 + 100;

       return  sin ( xx / 100) * cos ( zz / 100 ) * 20 -
		cos ( 2.5 * a ) * exp ( -1.2 * a) * 290 + 340;

//	return sqrt ( 250000. - xx * xx - zz * zz) - 100;       // ellipsoid

//	return  sqrt ( xx * xx + zz * zz );                     // cone

//	return  ( xx * xx + zz * zz ) / 500;                    // paraboloid

//	return  ( xx * xx - zz * zz ) / 500 + 250;   // hyperbolic paraboloid
}

void horizont (int x1, float y1, int x2, float y2, float high[], float low[])
{
    int xtemp;
    float slope, ytemp;
    if ( x2 == x1 )	{
	high [ x2 ] = max ( high [ x2 ], y2 );
	low [ x2 ] = min ( low [ x2 ], y2 );
    }  else {
	 slope = ( y2 - y1 ) / ( x2 - x1 );
	 for ( xtemp = x1; xtemp <= x2; xtemp += 5 )  {
	       ytemp = slope * ( xtemp - x1 ) + y1;
	       high [ xtemp ] = max ( high [ xtemp ], ytemp );
	       low [ xtemp ] = min ( low [ xtemp ], ytemp );
	 }
    }
}

int visible ( int x, float y, float high[], float low[] )
{
    if ( y < high [ x ] && y > low [ x ] ) return 0;
    if ( y >= high [ x ] ) return 1;
    return -1;
}

void intersection (int x1, float y1, int x2, float y2, float array[],
			int  *xinter, float *yinter)
{
     int ysign, csign;
     float slope;
     if ( x2 == x1 ) {
	*xinter = x2;
	*yinter = array [ x2 ] ;
     }  else {
	slope = ( y2 - y1 ) / ( x2 - x1 );
	ysign = SIGN ( y1 + slope - array [ x1 + 1 ] );
	csign = ysign;
	*yinter = y1 + slope;
	*xinter = x1 + 1;
	while ( csign == ysign) {
	     *yinter += slope;
	     ( *xinter )++;
	     csign = SIGN ( *yinter - array [ *xinter ] );
	}
	if ( fabs ( *yinter - slope - array [ *xinter - 1 ] ) <=
		      fabs( *yinter - array [ *xinter ] ) )  {
		*yinter -= slope;
		( *xinter )--;
	 }
     }
}

void main()
{
     int  xmin = 0, xmax=639, zmin =0 , zmax = 639, dx = 5, dz = 10, x, z;
     int xprev, xinter, xleft, i, flag_cur, flag_prev, driver = DETECT, mode;
     float y, yprev, yinter, yleft, high[640], low[640];

     initgraph(&driver, &mode, "");

     xleft = yleft = -1;
     for ( i = 0; i < 640; i++)  {
	high [ i ] = 0;
	low [ i ] = YMAX;
     }

     for ( z = zmax ; z  >= zmin; z -= dz )
     {
	xprev = xmin;
	yprev = function( xmin, z );
	if (xleft != -1) horizont (xleft, yleft, xprev, yprev, high, low);
	xleft = xprev;
	yleft = yprev;
	flag_prev = visible ( xprev, yprev, high, low);
	for ( x = xmin; x <= xmax ; x+= dx)
	{
	     y = function( x, z );
	     flag_cur = visible(x, y, high, low);
	     if ( flag_cur == flag_prev )
	     {
		  if ( flag_cur == 1 || flag_cur == -1 )	 {
			line ( xprev, YMAX - yprev, x, YMAX - y);
			horizont ( xprev, yprev, x, y, high, low );
		   }
	      }   else  {
		  if (flag_cur == 0)  {
		      if (flag_prev == 1) intersection ( xprev, yprev, x, y,
				high, &xinter, &yinter );
		      else  intersection ( xprev, yprev, x, y,
				low, &xinter, &yinter );
		      line ( xprev, YMAX - yprev, xinter, YMAX - yinter );
		      horizont ( xprev, yprev, xinter, yinter, high, low );
		  }   else   {
		      if (flag_cur == 1)  {
			  if (flag_prev == 0)  {
			       intersection ( xprev, yprev, x, y, high,
				      &xinter, &yinter );
			       horizont ( xinter, yinter, x, y, high, low );
			  }   else   {
			       intersection ( xprev, yprev, x, y, low,
				     &xinter, &yinter );
			       line (xprev, YMAX-yprev, xinter, YMAX-yinter);
			       horizont ( xprev, yprev, xinter, yinter,
				       high, low );
			       intersection ( xprev, yprev, x, y, high,
				       &xinter, &yinter );
			       line ( xinter, YMAX - yinter, x, YMAX - y );
			       horizont ( xinter, yinter, x, y, high, low );
			  }
		      }    else    {
			  if (flag_prev == 0) {
			       intersection ( xprev, yprev, x, y, high,
					&xinter, &yinter );
			       line ( xinter, YMAX - yinter, x, YMAX - y );
			       horizont(xinter, yinter, x, y, high, low);
			  }    else   {
			       intersection(xprev, yprev, x, y, high,
					&xinter, &yinter);
			       line(xprev, YMAX-yprev, xinter, YMAX-yinter);
			       horizont(xprev, yprev, xinter, yinter,
					high, low);
			       intersection(xprev, yprev, x, y, low,
					&xinter, &yinter);
			       line(xinter, YMAX-yinter, x, YMAX-y);
			       horizont(xinter, yinter, x, y, high, low);
			  }
		      }
		  }
	      }
	     flag_prev = flag_cur;
	     xprev = x;
	     yprev = y;
	}
     }
}