#include <iostream.h>                      // CLASS "FRACTION"
#include <stdlib.h>

class Fraction {
	int numerator, denominator;
public:
	Fraction ( int num = 0, int denom = 1 )  {
		if ( ! denom ) 	exit ( 1 ) ;
		numerator = num  ;
		denominator = denom ;
	}

	Fraction operator + ( Fraction ) const ;
	Fraction operator + ( int ) const ;
	void operator += ( Fraction );

	Fraction operator - ( const Fraction & ) const ;

	Fraction & operator -= ( const Fraction & );
	Fraction & operator -- ( );		// prefix
	Fraction & operator -- ( int );	// postfix

	Fraction operator * ( Fraction ) const ;
	Fraction operator / ( Fraction ) const ;
	int  operator == ( Fraction ) const ;

	void operator () ( Fraction ) ;
	void operator () ( int , int ) ;
	void operator () ( int );
	void operator () ( double );
	float operator () () const  ;

	operator float () const ;

	friend ostream & operator << ( ostream & , const Fraction & );
};
Fraction operator - ( const Fraction & );
bool  operator != ( const Fraction & , const Fraction & ) ;


ostream & operator << ( ostream & s , const Fraction & temp )
{
	if ( temp . denominator  != 1 )
		s << temp . numerator << " / " << temp. denominator ;
	else
		s << temp . numerator ;
	return s ;
}

istream &  operator >> ( istream  & s , Fraction  & temp )
{
	int  num , denom ;
	char sign ;
	s >> num >> sign >> denom ;
	temp = Fraction ( num, denom ) ;
	return s ;
}

Fraction  Fraction :: operator + ( Fraction  secondFraction ) const
{
	return Fraction ( numerator  * secondFraction . denominator +
			   denominator  * secondFraction . numerator ,
			   denominator  * secondFraction . denominator ) ;
}

Fraction Fraction :: operator + ( int secondInt ) const
{
	return Fraction ( numerator + secondInt * denominator , denominator ) ;
}

Fraction  operator + ( int  firstInt , Fraction  secondFraction )
{
	return  secondFraction + firstInt ;
}

void  Fraction :: operator += (  Fraction  secondFraction )
{
	* this = * this + secondFraction ;
}


Fraction Fraction :: operator - ( const  Fraction & secondFraction ) const
{
	return Fraction ( numerator  * secondFraction . denominator -
			   denominator  * secondFraction . numerator ,
			   denominator  * secondFraction . denominator ) ;
}

Fraction operator - (const Fraction & tempFraction ) 
{
	return Fraction () - tempFraction;
}

Fraction & Fraction :: operator -= ( const Fraction & F )
{
	* this = * this - F ;
	return * this ;
}

Fraction & Fraction :: operator -- ( ) /// prefix 
{
	numerator -= denominator ;
	return * this ;
}

Fraction & Fraction :: operator -- ( int ) /// postfix 
{
	numerator -= denominator ;
	return * this ;
}

Fraction Fraction :: operator * (  Fraction secondFraction ) const
{       return Fraction ( numerator * secondFraction.numerator ,
			  denominator * secondFraction.denominator );
}
Fraction Fraction :: operator / (  Fraction secondFraction ) const
{       return Fraction ( numerator * secondFraction.denominator ,
			  denominator * secondFraction.numerator );
}
Fraction operator ^ ( Fraction firstFraction , int secondInt )
{
	Fraction temp ( 1 , 1 );
	if ( secondInt > 0 )
		for ( int i = 0 ; i < secondInt ; i ++ )
			temp = temp * firstFraction ;
	if ( secondInt < 0 )
		for ( int i = 0 ; i > secondInt ; i -- )
			temp = temp / firstFraction ;
	return temp;
}

int  Fraction :: operator == (  Fraction secondFraction ) const
{       
	if ( numerator  *  secondFraction.denominator  == 
	     denominator  *  secondFraction.numerator  ) 
 		return  1;
 	return  0 ;
}

bool  operator != (  const Fraction & firstFraction , const Fraction & secondFraction )
{       
	if ( firstFraction == secondFraction )
		return  false ;
 	return  true ;
}


void Fraction :: operator () ( Fraction secondFraction )
{
	* this = Fraction ( secondFraction );
}
void Fraction :: operator () ( int tempNumer , int tempDenomir )
{
	* this = Fraction ( tempNumer , tempDenomir );
}
void Fraction :: operator () ( int tempNumer )
{
	* this = Fraction ( tempNumer );
}
void Fraction :: operator () ( double tempNumer )
{
	* this = Fraction ( ( int ) ( tempNumer * 1000 ), 1000 );
}

float Fraction :: operator () ( ) const
{
	return ( float ) numerator / denominator ;
}

Fraction :: operator float () const
{
	return ( float )numerator/ denominator;
}


void main ( void )
{
	Fraction A ( 1, 2 ), B ( 1, 4 ) , C, D, E;
/*	cout << "PUT FRACTION\n";
	cin >> B;
	cout << "PUT NUMBER\n";
	cin >> d;
*/
	C = A + B;
	cout << A << " + " << B << " = " << C << endl;
	C = A + 3;
	cout << A << " + 3 = " << C << endl;

	C = 3 + A ;
	cout << "3 + " << A << " = " << C << endl;

	C = - A;
	cout << C << endl ;

	C = A - B;
	cout << A << " - " << B << " = " << C << endl;

	C = A;
	D = C -= B ;
	cout << "D = " << D << "    C = " << C << endl;

	C = A;
	-- C;
	cout << C << endl;

	C = A;
	D = B + C --;
	cout << D << endl;

	C = A ^ 3;
	D = A ^ ( - 3 );
	cout << C << "   " << D << endl;

	if ( A == B )
		cout << "is equal\n";
	else
		cout << "isn't equal\n";

	C = 1;
	cout <<  C << endl;
	D = C = 4;
	cout << C << "   " << D << endl ;

	B ( A );
	C ( 1, 10 );
	D ( 121 );
	E ( 12.3456789 ) ;
	cout << B << "   " << C << "   " << D << "  " << E << endl;
	cout << C () << endl ;

    cout << A << " in float form  " << ( float ) A << endl;
}