#include <iostream.h>                      // ABSTRACT TYPE "ARRAY OF INTEGER"
#include <stdlib.h>

#define STOP -11111

class Array {
	unsigned int size;
	int * pArr;
public:	Array ( unsigned int _size = 0 , const int * pData = NULL ) ;
	Array ( int * pData ) ;
	Array ( const Array & );
	~Array () { if ( size ) delete [] pArr ; }
	int & operator [] ( int index ) {
		if ( index < 0 || index >= ( signed ) size )
			cout << "OUT OF ARRAY RANGE\n"  ,  exit ( 1 );
		return pArr [ index ] ;
	}
	Array & operator = ( const Array & );
	Array operator + ( const Array & ) const ;
	friend ostream & operator << ( ostream & , const Array & );
};

Array :: Array ( unsigned int _size , const int * pData )
{      	size = _size;
	if ( size ) {
		pArr = new int [ size ];
		if ( pData )  for ( unsigned i = 0; i < size ; i ++ )
				       pArr [ i ] = pData [ i ];
	}
}

Array :: Array ( int * pData )
{	unsigned int  length = 0 ;
	for ( int  * pTemp = pData  ; * pTemp != STOP ; pTemp ++ )
		length ++;
	size = length ;
	if ( size ) {
		pArr = new int [ size ] ;
		for ( unsigned  i = 0 ; i < size; i ++ )
			pArr [ i ] = pData [ i ] ;
	}
	else
		pArr = NULL ;
}

Array :: Array ( const Array & arr2 )
{
	size = arr2 . size ;
	pArr = new int [ size ];
	for ( unsigned i = 0 ; i < size ; i ++ )
		pArr [ i ] = arr2. pArr [ i ] ;
}

Array & Array :: operator = ( const Array & arr2 )
{       if ( size != arr2.size ) {
		if ( size )  delete [ ] pArr ;
		size = arr2 . size ;
		pArr = new int [ size ];
	}
	for ( unsigned i = 0 ; i < size ; i ++ )
		pArr [ i ] = arr2. pArr [ i ] ;
	return * this ;
}

Array Array :: operator + ( const Array & arr2 ) const
{   
	if ( size >= arr2.size ) {
		Array temp ( * this );
		for ( unsigned i = 0 ; i < arr2.size ; i ++ )
			temp [ i ] += arr2.pArr [ i ] ;
		return temp;
	}
	Array temp ( arr2 );
	for ( unsigned i = 0 ; i < size ; i ++ )
		temp [ i ] += pArr [ i ] ;
	return temp;
}

ostream & operator << ( ostream & s , const Array & temp )
{	s << "{ " ;
	for ( unsigned i = 0; i < temp.size ; i++ )
		s << temp.pArr [ i ] << ", " ;
	s << "\b\b }" ;       return s ;
}
void main ( void )
{
	int  dataC [ ]  = { 1 , 2 , 3 , 4 , 5 } , dataD [ ]  = { 1 , 2 , 3 , STOP } ;
	Array  A , B ( 2 ) , C ( 5 , dataC ) , D ( dataD );
	A = C + D ;
	cout << C << " + " << D << " = " << A << endl;
	B [ 0 ] = B [ 1 ] = 10 ;
	cout << B ;
}

