#include <iostream.h>                      // ABSTRACT TYPE "ARRAY OF INTEGER"
#include <stdlib.h>
#include <stdarg.h>

#define STOP -11111

class Array {
	unsigned int size;
	int * pArr;
public:
	Array () { size = 0; }
	Array ( int * pData ) ;
	Array ( int , ... ) ;
	Array ( const Array & );
	~Array () { if ( size ) delete [] pArr ; }
	int & operator [] ( int index ) {
		if ( index < 0 || index >= ( signed ) size )
			cout << "OUT OF ARRAY RANGE\n"  ,  exit ( 1 );
		return pArr [ index ] ;
	}
	Array & operator = ( const Array & );
	Array operator + (const  Array & ) const ;
	friend ostream & operator << ( ostream & , const Array & );
};
Array globalTempArray ;

Array :: Array ( int * pData )
{
	unsigned int  length = 0 ;
	for ( int  * pTemp = pData  ; * pTemp != STOP ; pTemp ++ )
		length ++;
	size = length ;
	if ( size ) {
		pArr = new int [ size ] ;
		for ( unsigned i = 0 ; i < size; i ++ )
			pArr [ i ] = pData [ i ] ;
	}
	else
		pArr = NULL ;
}

Array :: Array ( int first, ... )
{
	va_list myArg;
	va_start ( myArg , first );

	unsigned int  length = 0 ;
	int temp = first ;
	while ( temp != STOP ) {
		temp = va_arg ( myArg, int );
		length ++ ;
	}
	size = length ;
	if ( size ) {
		pArr = new int [ size ] ;
		pArr [ 0 ] = first ;
		va_start ( myArg , first );
		for ( unsigned i = 1 ; i < size; i ++ )
			pArr [ i ] =  va_arg ( myArg, int );
	}
	va_end ( myArg );
}

Array :: Array ( const Array & arr2 )
{
	size = arr2 . size ;
	pArr = new int [ size ];
	for ( unsigned i = 0 ; i < size ; i ++ )
		pArr [ i ] = arr2. pArr [ i ] ;
}

Array & Array :: operator = ( const Array & arr2 )
{       if ( size != arr2.size ) {
		if ( size )  delete [ ] pArr ;
		size = arr2 . size ;
		pArr = new int [ size ];
	}
	for ( unsigned i = 0 ; i < size ; i ++ )
		pArr [ i ] = arr2. pArr [ i ] ;
	return * this ;
}
Array Array :: operator + ( const Array & arr2 ) const
{   
	if ( size >= arr2.size ) {
		Array temp ( * this );
		for ( unsigned i = 0 ; i < arr2.size ; i ++ )
			temp [ i ] += arr2.pArr [ i ] ;
		return temp;
	}
	Array temp ( arr2 );
	for ( unsigned i = 0 ; i < size ; i ++ )
		temp [ i ] += pArr [ i ] ;
	return temp;
}
ostream & operator << ( ostream & s , const Array & temp )
{	s << "{ " ;
	for ( unsigned i = 0; i < temp.size ; i++ )
		s << temp.pArr [ i ] << ", " ;
	s << "\b\b }" ;       return s ;
}
void main ( void )
{
	int  dataB [ ]  = { 1 , 2 , 3 , 4 , 5, STOP } ;
	Array  A , B ( dataB ), C ( 6, 7, 8, STOP );
	A = B + C ;
	cout << B << " + " << C << " = " << A << endl;
}

