#include <iostream.h>                       // ABSTRACT TYPE "MATRIX"
#include <conio.h>

inline int max ( int a , int b )
{
	return  a >  b  ?  a  :  b ;
}

class Matrix {
	unsigned column , row ;
	int ** ppMatr;
public:
	Matrix ( unsigned = 0 , unsigned = 0, int * = NULL ) ;
	Matrix ( Matrix & );
	~Matrix ();
	int * & operator [] ( int );
	Matrix operator+ ( Matrix & ) ;  /////// const ;
	Matrix & operator= ( Matrix & );
	friend ostream & operator<< ( ostream &, Matrix & );
};

Matrix :: Matrix ( unsigned c , unsigned r , int * data )
{
	column = c ;
	row = r ;
	if ( column == 0 || row == 0 ) 
		return ;
	ppMatr = new int * [ column ];
	unsigned counter = 0 ;
	for ( unsigned i = 0; i < column ; i ++ ) {
		ppMatr [ i ] = new int [ row ];
		if ( data )
			for ( unsigned j = 0; j < row ; j++ )
				ppMatr [ i ][ j ] = data [ counter ++ ];
		else
			for ( unsigned j = 0; j < row ; j++ )
				ppMatr [ i ][ j ] = 0 ;
	}
}

Matrix :: Matrix ( Matrix & second )
{       
	column = second.column ;
	row = second.row ;
	if ( column == 0 || row == 0 ) 
		return ;
	ppMatr = new int * [ column ];
	for ( unsigned i = 0; i < column ; i++ ) {
		ppMatr [ i ] = new int [ row ];
		for ( unsigned j = 0; j < row ; j++ )
			ppMatr [ i ][ j ] = second [ i ][ j ];
	}
}

Matrix :: ~Matrix ()
{
	if ( column && row ) {
		for ( unsigned i = 0; i < column ; i++ )
			delete [ ] ( ppMatr [ i ] ) ;
		delete [ ] ppMatr;
	}
}

int * & Matrix :: operator [] ( int index )
{
	return ppMatr [ index ];
}

ostream & operator<< ( ostream & s, Matrix & second )
{
	for ( unsigned i = 0; i < second.column ; i++ ) {
		for ( unsigned j = 0; j < second.row ; j ++ )
			s << second [ i ][ j ] << "  " ;
		s << '\n';
	}
	s << "\n\n" ;
	return s ;
}

Matrix Matrix :: operator+ ( Matrix & second ) //// const
{
		Matrix temp ( max ( column , second.column ), max ( row , second.row ) ) ;
		for ( unsigned i = 0 ; i < column ; i ++ )
			for ( unsigned j = 0 ; j < row ; j ++ )
				temp [ i ][ j ] = ( * this )[ i ][ j ]; ////ppMatr [ i ][ j ];
		for ( i = 0 ; i < second.column ; i ++ )
			for ( unsigned j = 0 ; j < second.row ; j ++ )
				temp [ i ][ j ] += 	second [ i ][ j ] ;
		return temp ;
}

Matrix & Matrix :: operator = ( Matrix & second )
{
	if ( column != second.column || row != second.row  ) {
		if ( column && row ) {
			for ( unsigned i = 0; i < column ; i++ )
				delete [ ] ( ppMatr [ i ] ) ;
			delete [ ] ppMatr;
		}
		column = second.column ;
		row = second.row ;
		if ( column && row ) {
			ppMatr = new int * [ column ];
			for ( unsigned i = 0; i < column ; i++ )
				ppMatr [ i ] = new int [ row ];
		}
	}
	for ( unsigned i = 0 ; i < column ; i ++ )
		for ( unsigned j = 0 ; j < row ; j ++ )
			( * this ) [ i ][ j ] = second [ i ][ j ];
	return * this ;
}

void main ( void )
{
	int data1 [] = { 1, 2, 3, 4 , 5 , 6 } ,
	    data2 [] = { 1, 2, 3, 4 , 5 ,6, 7, 8, 9, 10 , 11, 12 };

	Matrix A ( 2 , 3 , data1 ) , B ( 3 , 4 , data2 ), C ;
	C = A + B ;
	cout << A << B << C;
}