#include <iostream.h>                      // CLASS "FRACTION"

class Fraction {
	int numerat;
	unsigned int denomirat;
public:
	Fraction ( int num = 0, unsigned int denom = 1 ) : numerat ( num ), denomirat ( denom )
		{ }
	Fraction operator + ( Fraction ) const ;
	Fraction operator - ( Fraction ) const ;
	Fraction operator * ( Fraction ) const ;
	friend ostream & operator << ( ostream & ,  const Fraction & );
};
istream & operator >> ( istream & , Fraction & );

ostream & operator << ( ostream & s ,  const Fraction & temp )
{       if ( temp.denomirat != 1)
		s << temp.numerat << " / " << temp.denomirat;
	else	s << temp.numerat;
	return s ;
}

istream & operator >> ( istream & s , Fraction & temp )
{      	int num ;
	unsigned int den ;
	char sign ;
	s >> num >> sign >> den;
	temp = Fraction ( num , den );
	return s ;
}

Fraction  Fraction :: operator + ( Fraction secondFraction )  const
{       return Fraction ( numerat * secondFraction.denomirat + denomirat * secondFraction.numerat,
			  denomirat * secondFraction.denomirat );
}

Fraction  Fraction :: operator - ( Fraction secondFraction )  const
{       return * this + Fraction ( -secondFraction.numerat, secondFraction.denomirat );
}

Fraction Fraction :: operator * (  Fraction secondFraction )  const
{       return Fraction ( numerat * secondFraction.numerat ,
			  denomirat * secondFraction.denomirat );
}

class ComplexOfFractions {
	Fraction  real , image ;
public:
	ComplexOfFractions ( int , int , int , int ) ;
	ComplexOfFractions ( Fraction , Fraction ) ;
	ComplexOfFractions operator + ( ComplexOfFractions ) const ;
	ComplexOfFractions operator - ( ComplexOfFractions ) const ;
	ComplexOfFractions operator * ( ComplexOfFractions ) const ;
	friend ostream & operator << ( ostream & ,  const ComplexOfFractions & );
};
istream & operator >> ( istream & , ComplexOfFractions & );

ostream & operator << ( ostream & s ,  const ComplexOfFractions & temp )
{
	s << temp.real << " + i * " << temp.image;
	return s ;
}

istream & operator >> ( istream & s , ComplexOfFractions & temp )
{       Fraction r, i;
	s >> r >> i;
	temp = ComplexOfFractions ( r, i );
	return s ;
}

ComplexOfFractions :: ComplexOfFractions ( int i1 , int i2 , int i3 , int i4 )
	: real ( i1 , i2 ) , image ( i3 , i4 )
{
}

ComplexOfFractions :: ComplexOfFractions ( Fraction f1 = Fraction ( 0 , 1 ),
	Fraction f2 = Fraction ( 0, 1 ) ) : real ( f1 ) , image ( f2 )
{
}

ComplexOfFractions  ComplexOfFractions ::
	operator + ( ComplexOfFractions second )  const
{
	return ComplexOfFractions ( real + second.real, image + second.image );
}

ComplexOfFractions  ComplexOfFractions ::
	operator - ( ComplexOfFractions second )  const
{
	return ComplexOfFractions ( real - second.real, image - second.image );
}

ComplexOfFractions ComplexOfFractions ::
	operator * (  ComplexOfFractions second )  const
{
	return ComplexOfFractions ( real * second.real - image * second.image ,
		  real * second.image + real * second.image );
}

void main ( void )
{
	Fraction DataFraction_1 ( 1, 2 ), DataFraction_2 ( 3 , 4 );
	ComplexOfFractions A ( 5, 6, 7, 8 ), B ( DataFraction_1, DataFraction_2 ), C ;

	cout << A << "  +  " << B << "  =  " << A + B << endl ;
	cout << A << "  -  " << B << "  =  " << A - B << endl ;
	cout << A << "  *  " << B << "  =  " << A * B << endl ;

	cout << "Put two Fractions in form  # / #  \n" ;
	cin >> C ;
        cout << C ;

}