#include <iostream.h>		// class Vector ( Fraction x, y, z )

class Fraction {
	int num, denom;
public:
	Fraction ( int n = 0, int d = 1 ) : num ( n ), denom ( d ) { }
	Fraction operator + ( Fraction ) const ;
	Fraction operator * ( Fraction ) const ;

	friend ostream & operator << ( ostream & , const Fraction & );
};

Fraction Fraction :: operator+ ( Fraction b )  const
{       return Fraction ( num * b.denom + denom * b.num , denom * b.denom );
}

Fraction Fraction :: operator * ( Fraction b ) const
{       return Fraction ( num * b.num , denom  * b. denom );
}

ostream & operator<< ( ostream & s, const Fraction & temp )
{
	s << temp.num << " / " << temp.denom;
	return s ;
}

class Vector {
	Fraction x, y, z;
public :
	Vector ( int x1 = 0, int x2 = 1, int y1 = 0, int y2 = 1, int z1 = 0,
		int z2 = 1 ) : x ( x1, x2 ), y ( y1, y2 ) , z ( z1, z2 ) { }
	Vector ( Fraction xx, Fraction yy, Fraction zz ) : x ( xx ),
		y ( yy ) , z ( zz ) { }
	Vector operator+ ( Vector ) const ;
	friend Vector operator * ( Vector, Fraction ) ;
	friend ostream & operator << ( ostream & , const Vector & );
};
Vector Vector :: operator+ ( Vector b )  const
{
	return Vector ( x + b.x, y + b.y, z + b.z );
}
Vector operator* ( Vector a, Fraction b )
{
	return Vector ( a.x * b, a.y * b, a.z * b );
}
ostream & operator<< ( ostream & s, const Vector & temp )
{
	s << "{ " << temp.x << " , " << temp.y << " , " << temp.z << " }";
	return s ;
}

void main ( void )
{
	Fraction f1 ( 1, 2 ), f2 ( 3, 4 ), f3 ( 5, 6 );
	Vector v1 , v2 ( 7, 8, 9, 10, 11, 12 ), v3 ( f1, f2, f3 );
	v1 = v2 + v3;
	cout << v2 << " + " << v3 << " = " << v1 << endl;
// OUTPUT  { 7 / 8 , 9 / 10 , 11 / 12 } + { 1 / 2 , 3 / 4 , 5 / 6 } =
//	   { 22 / 16 , 66 / 40 , 126 / 72 }
	v1 = v2 * f1 ;
	cout << v2 << " * " << f1 << " = " << v1 << endl;
// OUTPUT  { 7 / 8 , 9 / 10 , 11 / 12 } * 1 / 2 = { 7 / 16 , 9 / 20 , 11 / 24 }
}
