#include <iostream.h>
#define N 6

class Number {
protected: unsigned int value;
	   Number ( int v ) { value = v ; }      // protected or public
public:	bool operator > ( const Number & second ) const { 
			return value > second.value ; 
	}
	virtual void print () const = 0;
};

class Decimal : public Number {
public: Decimal ( int v = 0 ) : Number ( v ) { }
	  void print () const { cout << "Decimal  " << dec << value << endl; }
};

class Octal : public Number {
public:   Octal ( int v = 0 ) : Number ( v ) { }
	  void print () const { cout << "Octal  " << oct << value << endl; }
};

class Hexadecimal : public Number {
public:    Hexadecimal ( int v = 0 ) : Number ( v ) { }
	   void print () const { cout << "Hexadecimal  " << hex << value << endl; }
};

void main ( void )
{
	Number * arrPNumber [ N ] = { & Decimal ( 25 ), & Decimal ( 10 ),
				    & Octal ( 5 ), & Octal ( 40 ),
				    & Hexadecimal ( 15 ) ,  & Hexadecimal ( 30 ) };

	for ( int i = 0 ; i < N ; i ++ )
		arrPNumber [ i ] -> print ();

	unsigned int indexMax = 0;
	for ( i = 1 ; i < N ; i ++ )
		if ( * arrPNumber [ i ] > * arrPNumber [ indexMax ] )
		       indexMax = i ;

	cout << "\nMax Element  ";
	arrPNumber [ indexMax ] -> print ();
}
