/*	               Base  unsigned day
//	            /       |          \
//	          /         |            \
//	   Day_Month       Day_In_Year     Day_Week
//    unsigned month                  usigned week
*/
#include <iostream.h>
#include <stdlib.h>

#define SIZE 6

unsigned daysInWonth [ 12 ] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
unsigned firstDayYear_In_Week = 4 ;

class Day_In_Year ;			// Pre - declaration

class Base {
protected: unsigned day ;
public: Base ( unsigned d = 1 ) { day = d ; }
	 virtual void print () const = 0 ;
	 virtual Day_In_Year operator ~ ( ) const = 0 ;
};

class Day_In_Year : public Base {
public:	Day_In_Year ( unsigned d = 1 ) : Base ( d ) { }
	void print ()  const { cout << "Day_In_Year : day  " << day << endl ; 	}
	Day_In_Year operator ~ ( )  const { return * this; }
	int operator - (  const Day_In_Year & second ) const {
		return day - second.day ;
	}
};

class Day_Month : public Base {
	unsigned month ;
public:	Day_Month ( unsigned d = 1 , unsigned m = 1 ) : Base ( d ) {
		month = m ;
	}
	void print ()  const { cout << "Day_Month : day  " << day << " , month  " <<
		month << endl ;
	}
	Day_In_Year operator ~ ( ) const ;
};

Day_In_Year Day_Month :: operator ~ ( )  const 
{
	unsigned result = 0 ;
	for ( unsigned i = 0 ; i < month - 1 ; i ++ )
		result += daysInWonth [ i ] ;
	result += day ;
	return  Day_In_Year ( result ) ;
}

class Day_Week : public Base {
	unsigned week ;
public:	Day_Week ( unsigned d = 1 , unsigned w = 1 ) : Base ( d ) {
			week = w ;
	}
	void print ()  const { cout << "Day_Week : day  " << day << " , week  " <<
		week << endl ;
	}
	Day_In_Year operator ~ ( ) const {
		return  Day_In_Year ( day - firstDayYear_In_Week + 1 + 7 * ( week - 1 ) );
	}
};

void main ( void )
{
	Base * arrBase [ SIZE ] = {
		& Day_Week ( 6 , 17 ) , & Day_In_Year ( 231 ) ,
		& Day_Month ( 28 , 2 ) , & Day_In_Year ( 111 ) ,
		& Day_Week ( 6 , 40 ) , & Day_Month ( 4 , 10 )
	};

	for ( int i = 0; i < SIZE ; i ++ )
		arrBase [ i ] -> print ();
		//  Day_Week     : day  6  ,  week  17
		//  Day_In_Year  : day  231
		//  Day_Month    : day  28 , month  2
		//  Day_In_Year  : day  111
		//  Day_Week     : day  6 , week  40
		//  Day_Month    : day  4 , month  10

	unsigned int minDelta = 366 , firstIndex , secondIndex , delta ;

	for ( i = 0 ; i < SIZE ; i ++ )
		for ( int j = i + 1 ; j < SIZE ; j ++ ) {
			delta = abs ( ~ ( * arrBase [ i ] ) - ~ ( * arrBase [ j ] ));
			if ( delta < minDelta ) {
				minDelta = delta;
				firstIndex = i ;
				secondIndex = j ;
			}
		}

	cout << "\nTwo nearest dates :   difference  " << minDelta << "  day\n" ;
	arrBase [ firstIndex ] -> print () ;
	arrBase [ secondIndex ] -> print () ;
}
