//		       	    String ( char * pStart )
//		       /     |       \
//		     /       |         \
//       Point_Size      Point_Null   Point_Point
//       unsigned size                char * pEnd

#include <iostream.h>
#include <string.h>
#define N 8

class String {
protected : char * pStart ;
public:	 String ( char * pS = NULL ) { pStart = pS ; }
	 virtual ~String ( ) { }   	// virtual destructor
	 virtual void print () const = 0 ;
	 virtual unsigned sizeOut () const = 0 ;
	 char * startOut () const { return pStart ; }
};

class Point_Size : public String {
	 unsigned size ;
public:	 Point_Size ( char * pS = NULL );
	 void print () const ;
	 unsigned sizeOut () const { return size ; }
};

Point_Size :: Point_Size ( char * pS )
{
	size = strlen ( pS );
	if ( size ) {
		pStart = new char [ size ] ;
		char * p = pStart ;
		while ( * pS )	* p ++ = * pS ++ ;
	}
}
void Point_Size :: print ( ) const
{
	cout << "\nPointer_Size  : ";
	for ( int i = 0 ; i < size ; i ++ )
		cout << pStart [ i ] ;
}

class Point_Null : public String {
public:	 Point_Null ( char * pS = NULL ) {
		int Size = strlen ( pS );
		if ( Size ) {
			pStart = new char [ Size + 1 ] ;
			strcpy ( pStart , pS );
		}
	}
	void print () const { cout << "\nPointer_Null : "  << pStart ; }
	unsigned sizeOut () const { return strlen ( pStart ); }
	void operator += ( const String & ) ;
};

void Point_Null :: operator += ( const String & s )
{
	Point_Null result = * this;
	char * pResult =  new char [ sizeOut () + s . sizeOut () + 1 ],
	     * pFirst, * pSecond = s . startOut () ;
	strcpy ( pResult, pStart );
	pFirst = pResult + strlen ( pResult );
	for ( int i = 0; i < s. sizeOut (); i ++ )
		* pFirst ++ = * pSecond ++ ;
	* pFirst = 0;

	if ( pStart )
		delete pStart ;
	pStart = pResult ;
}

class Point_Point : public String {
	 char * pEnd ;
public:	 Point_Point ( char * pS = NULL );
	 void print () const;
	 unsigned sizeOut () const { return pStart ? pEnd - pStart + 1 : NULL ; }
};

Point_Point :: Point_Point ( char * pS )
{
	int Size = strlen ( pS );
	if ( Size ) {
		pStart = new char [ Size ] ;
		char * p = pStart ;
		while ( * pS )
			* p ++ = * pS ++ ;
		pEnd = p - 1 ;
	}
	else	pEnd = NULL ;
}
void Point_Point :: print ( ) const
{
	cout << "\nPointer_Pointer  : ";
	for ( char * p = pStart ; p <= pEnd ; p ++ )
		cout << * p ;
}

void main ( void )
{
	String * arrPStrings [ N ] =
		{ new Point_Size ( "father " )  , new Point_Null ( "mother " ) ,
		  new Point_Point ( )           , new Point_Point ( "sister " ) ,
		  new Point_Size ( "brother " ) , new Point_Null ( "grandfather " ) ,
		  new Point_Size ( )            , new Point_Point ( "grandmother " ) } ;

	for ( int i = 0; i < N ; i ++ )
		arrPStrings [ i ] -> print ();
					  //  Point_Size  :    father
					  //  Point_Null  :    mother
					  //  Point_Point :
					  //  Point_Point :    sister
					  //  Point_Size  :    brother
					  //  Point_Null  :    grandfather
					  //  Point_Size  :
					  //  Point_Point :    grandmother
	Point_Null tempPoint_Null ;
	for ( i = 0; i < N ; i ++ )
		tempPoint_Null +=  * arrPStrings [ i ] ;
	tempPoint_Null.print ();
  //  Point_Null  :   father mother sister brother grandfather grandmother

	for ( i = 0; i < N ; i ++ )
		delete arrPStrings [ i ] ;

}

