// 				Abstract class  Base  ( radius )
//			virtual	  /	        \    virtual
//                              /               Radius_height ( height )
//                            /         virtual /   \ virtual
//	                HalfBall         Cylinder     Cone
//  HalfBall_Cone   HalfBall_Cylinder   HalfBall_Cylinder_Cone  Cylinder_Cone

#include <iostream.h>
#define N 7

class Base {
protected: float rad;
	Base ( float r = 0 ) { rad = r; }
	float area () const { return 3.1415926 * rad * rad; }
public: virtual float volume () const = 0 ;
	virtual void print() const = 0;

};

class Radius_Height : virtual public Base {
protected: float height;
	Radius_Height ( float h  = 0 ) { height = h; }
public: virtual float volume () const = 0 ;
	virtual void print() const = 0;
};

class HalfBall: virtual public Base {
public: HalfBall ( float r = 0 ) : Base ( r ) { }
	float volume () const { return area () * 4 / 3 * rad / 2 ; }
	void print() const { cout << "\nHalfBall :  radius " << rad
		<< "  volume " << volume(); }
};

class Cylinder : virtual public Radius_Height {
public: Cylinder ( float r = 0 , float h = 0 ) : Radius_Height ( h ), Base ( r ) { }
	float volume () const { return area() * height ; }
	void print() const { cout << "\nCylinder :  radius " << rad
		<< "  height " << height << "  volume " << volume(); }
};

class Cone : virtual public Radius_Height {
public: Cone ( float r = 0 , float h = 0 ) : Radius_Height ( h ), Base ( r ) { }
	float volume () const { return area() / 3 * height ; }
	void print() const { cout << "\nCone :  radius " << rad
		<< "  height " << height << "  volume " << volume(); }
};

class HalfBall_Cylinder: public HalfBall, public Cylinder {
public: HalfBall_Cylinder ( float r = 0, float h = 0 ) : Radius_Height ( h ) , Base ( r ) { }
	float volume () const { return HalfBall :: volume ( ) +
		Cylinder::volume ();}
	void print ( ) const { cout << "\nHalfBall_Cylinder:  radius "
		<< rad  << "  height " << height << "  volume " << volume(); }
};

class HalfBall_Cone: public HalfBall, public Cone {
public: HalfBall_Cone ( float r = 0, float h = 0 ) : Radius_Height ( h ), Base ( r ) { }
	float volume () const { return HalfBall :: volume ( ) + Cone :: volume ();}
	void print ( ) const { cout << "\nHalfBall_Cone:  radius " << rad  <<
		"  height " << height << "  volume " << volume(); }
};

class Cylinder_Cone: public Cylinder , public Cone {
public: Cylinder_Cone ( float r = 0, float h = 0 ) : Radius_Height ( h ) , Base ( r ) { }
	float volume () const { return Cylinder :: volume ( ) +
		Cone :: volume (); }
	void print ( ) const { cout << "\nCylinder_Cone:  radius " << rad
		<< "  height " << height << "  volume " << volume(); }
};

class HalfBall_Cylinder_Cone: public HalfBall, public Cylinder, public Cone {
public: HalfBall_Cylinder_Cone ( float r, float h ) : Radius_Height ( h ) ,
		Base ( r ) { }
	float volume () const { return HalfBall :: volume ( ) +
		Cylinder::volume () + Cone :: volume ();}
	void print ( ) const { cout << "\nHalfBall_Cylinder_Cone:  radius "
		<< rad << "  height " << height << "  volume " << volume(); }
};

void main ()
{
	Base * baseArr [ N ] = { & HalfBall ( 5 ),  & Cylinder ( 3, 4 ),
		& Cone ( 2, 3 ),  & HalfBall_Cylinder ( 1, 6 ),
		& HalfBall_Cone ( 4, 3 ),  & Cylinder_Cone ( 7, 5 ),
		& HalfBall_Cylinder_Cone ( 2, 4 ) };

	for ( int i = 0 ; i < N ; i ++ )
		 baseArr [ i ] -> print ();

	int indexMax = 0;
	for ( i = 1; i < N ; i ++ )
	     if ( baseArr[ i ] -> volume () > baseArr[ indexMax ] -> volume ())
			indexMax = i;
	cout << "\n\nMax Volume :  ";
	baseArr [ indexMax ] -> print ();
}