//			       Base ( family )
//				    !
//				Mark ( mark )
//                       /          !          \
//         	HomeWorks  	Examen  	Project
//			 \       /      \       /
//	        HoneWorrks_Examen     Project_Examen

#include <iostream.h>
#include <string.h>

#define N 6

class Base {
protected: char family [ 20 ];
	Base ( char * f = 0 ) { strcpy ( family , f ); }
public:
	virtual int finalMarkOut () const = 0;
	virtual void print () const = 0;
};

class Mark : virtual public Base {
protected: int mark;
public: Mark ( int m ) { mark = m; }
	virtual int finalMarkOut () const = 0;
	virtual void print() const  = 0;
};

class HomeWorks: public Mark {
public: HomeWorks ( int m ) : Mark ( m ) { }
	virtual int finalMarkOut ()  const = 0;
	virtual void print()  const = 0;
};

class Examen : public Mark {
public: Examen ( int  m ) : Mark ( m ) { }
	virtual int finalMarkOut () const = 0;
	virtual void print() const = 0;
};

class Project : public Mark {
public: Project ( int m ) : Mark ( m ) { }
	virtual int finalMarkOut () const = 0;
	virtual void print() const = 0;
};

class HomeWorks_Examen : public HomeWorks , public Examen {
public: HomeWorks_Examen ( char * f , int m1 , int m2 ) : HomeWorks ( m1 ),
		Examen ( m2 ) , Base ( f ) { }
	int finalMarkOut () const { return HomeWorks :: mark * 0.2 + Examen :: mark * 0.8 ; }
	void print() const { cout << "\nHomeWorks_Examen : family  " << family
		<< "   HomeWorks mark  " << HomeWorks :: mark
		<< "   Examen mark  " << Examen :: mark ; }
};

class Project_Examen : public Project , public Examen {
public: Project_Examen ( char * f , int m1 , int m2 ) : Project ( m1 ),
		Examen ( m2 ) , Base ( f ) { }
	int finalMarkOut ()  const  { return Project :: mark * 0.5 + Examen :: mark * 0.5 ; }
	void print()  const  { cout << "\nProject_Examen : family  " << family
		<< "   Project mark  " << Project :: mark
		<< "   Examen mark  " << Examen :: mark ; }
};

void main ()
{
	Base * arrBase [ N ] = { & HomeWorks_Examen ( "Lewis_Carrol", 90 , 60 ),
	       & HomeWorks_Examen ( "Alice", 95 , 90 ),
	       & Project_Examen ( "Rabbit", 70 , 45 ),
	       & HomeWorks_Examen ( "Cheshire_Cat", 0 , 50 ),
	       & Project_Examen ( "Turtile", 100 , 95 ),
	       & Project_Examen ( "Caterpiller", 50 , 60 )
	};
	for ( int i = 0; i < N ; i ++ )
		arrBase [ i ] -> print ();

	cout <<"\n\nFail to pass a course: ";
	for ( i = 0; i < N ; i ++ )
		if ( arrBase [ i ] -> finalMarkOut() < 60 )
			arrBase [ i ] -> print ();
}