#include <iostream.h>
#include <typeinfo.h>

#define N  8

class Base {
	unsigned int first ;
	Base ( unsigned int f = 0 ) { first = f ;}
public: virtual ~ Base () { }
	unsigned int firstOut () const  { return first ; }
};

class Second_Side : virtual public Base {
	unsigned int second ;
protected: Second_Side ( unsigned int s ) { second = s ; }
public:	unsigned int secondOut ()  const { return second ; }
};

class Angle : virtual public Base {
	unsigned int angle ;
protected: Angle ( unsigned int a ) { angle = a ; }
public:	unsigned int angleOut ()  const { return angle ; }
};

class Square : public Base {
public:	Square ( unsigned int f ) : Base ( f ) { }
	void print () const { cout << "\nSquare : first = " << firstOut (); }
};

class Rectangle : public Second_Side {
public:	Rectangle ( unsigned int f, unsigned int s ) : Second_Side ( s ), Base ( f ) { }
	void print () const { cout << "\nRectangle : first = "
		<< firstOut () << "  second = " << secondOut ();
	}
};

class Parallelogram : public Second_Side, public Angle {
public:	Parallelogram ( unsigned int f, unsigned int s, unsigned int a ) : Second_Side ( s ), Angle ( a ), Base ( f ) { }
	void print () const { cout << "\nParallelogram : first = "
		<< firstOut () << "  second = " << secondOut () << "  angle = "
		<< angleOut ();
	}
};

class Rhomb : public Angle {
public:	Rhomb ( unsigned int f, unsigned int a ) : Angle ( a ), Base ( f ) { }
	void print ()  const { cout << "\nRhomb : first = " << firstOut ()
		<< "  angle = " << angleOut ();
	}
};

void printAllRectangles ( Base * arrBase [ ] )
{
	cout << "\nAll Rectangles :\n" ;
	for ( int i = 0 ; i < N ; i ++ ) {
		if ( typeid ( * arrBase [ i ] ) == typeid ( Rectangle ) )
			 dynamic_cast < Rectangle * > ( arrBase [ i ] ) -> print ();
		if ( typeid ( * arrBase [ i ] ) == typeid ( Square ) )
		 	dynamic_cast < Square * > ( arrBase [ i ] ) -> print ();
		if ( typeid ( * arrBase [ i ] ) == typeid ( Parallelogram ) &&
			 dynamic_cast < Parallelogram * > (arrBase [ i ] )-> angleOut ()== 90 )
         	    dynamic_cast < Parallelogram * > (arrBase [ i ] )-> print ();
      		if ( typeid ( * arrBase [ i ] ) == typeid ( Rhomb ) &&
			 dynamic_cast < Rhomb * > (arrBase [ i ] )-> angleOut ()== 90 )
         	    dynamic_cast < Rhomb * > (arrBase [ i ] )-> print ();
   }
}

void printAllRhombs ( Base * arrBase [ ] )
{
	cout << "\nAll Rhombs :\n" ;
	for ( int i = 0 ; i < N ; i ++ ) {
   	Rhomb * ptempRhomb = dynamic_cast < Rhomb * > (arrBase [ i ] );
		if ( ptempRhomb )
      	ptempRhomb -> print ();
   	Square * ptempSquare = dynamic_cast < Square * > (arrBase [ i ] );
		if ( ptempSquare )
      	ptempSquare -> print ();
   	Rectangle * ptempRectangle = dynamic_cast < Rectangle * > (arrBase [ i ] );
	if ( ptempRectangle && ptempRectangle -> secondOut() ==
 		ptempRectangle -> firstOut() )
      		ptempRectangle -> print ();
   	Parallelogram * ptempParallelogram = dynamic_cast < Parallelogram * > (arrBase [ i ] );
	if ( ptempParallelogram && ptempParallelogram -> secondOut() ==
      	  	ptempParallelogram -> firstOut() )
      		ptempParallelogram -> print ();
	}
}

void main ( void )
{
	Base * arrBase [ N ] = { new Square ( 5 ) , new Rectangle ( 3, 8 ) ,
		new Rectangle ( 4 , 4 ) , new Parallelogram ( 7, 5, 30 ),
		new Parallelogram ( 6, 6, 60 ), new Parallelogram ( 7, 7, 90 ),
		new Rhomb ( 3, 30 ) , new Rhomb ( 8, 90 ) };
	printAllRectangles ( arrBase );
	printAllRhombs ( arrBase );
	for (int i = 0; i < N ; i ++ ) delete arrBase [ i ];
}
