#include <iostream.h>
#include <math.h>
#include <typeinfo.h>

#define MIN( a, b ) a > b ? b : a
#define N  4

class Point {
	float x , y ;
public: Point ( float xx = 0 , float yy = 0 ) { x = xx; y = yy ; }
	unsigned int delta ( Point second ) const {
		return  MIN ( fabs ( x - second.x ) , fabs ( y - second.y ));
	}
	unsigned int Hypotenus ( Point second ) const {
		return  hypot ( x - second.x , y - second.y ) / 2 ;
	}
	friend ostream & operator << ( ostream & , const Point & );
};
ostream & operator << ( ostream & s , const  Point & temp )
{
	s << "( " << temp.x << " , " << temp.y << " )" ;
	return s ;
}

class Base {
protected: const Point _point ;
	static unsigned int _size ;
	Base ( Point _p = Point () ) : _point ( _p ) { }
	Base ( int x, int y ) : _point ( x, y ) { }
public: virtual ~Base () {}
	Point getPoint () const { return _point ; }
	static void setSize ( unsigned int _s ) { _size = _s ;}
	static unsigned getSize ( ) { return _size ;}
};

class Circle : public Base {
public: Circle ( Point _p = Point () ) : Base ( _p ) { }
	Circle ( int x, int y ) : Base ( x, y ) { }
	void print () const { cout << "\nCircle : Center " << _point << "  Diametr " << _size; }
};

class Square : public Base {
public: Square ( Point _p = Point () ) : Base ( _p ) { }
	Square ( int x , int y ) : Base ( x, y ) { }
	void print () const { cout << "\nSquare : Left Point " << _point << "  Size " << _size; }
};

unsigned Base :: _size;  // definition ( Allocate space )

void main ( void )
{
	Base * arrBase [ N ] = { new Circle ( 1, 1 ) , new Circle ( Point ( 10, 8 ) ),
			new Square ( 3, 4 ) , new Square ( Point ( 7, 10 ) )};
	Base :: setSize ( 20 );
   	
	for ( int i = 0; i < N ; i ++ )
   	if ( typeid ( * arrBase [ i ] ) == typeid ( Square ) )
      		dynamic_cast < Square * > ( arrBase [ i ] ) -> print ();
      	else
       		dynamic_cast < Circle * > ( arrBase [ i ] ) -> print ();

	unsigned int minSize = 9999 , temp ;
	for ( i = 0; i < N - 1 ; i ++ )
		for ( int j = i + 1 ; j < N ; j ++ ) {
			temp = 9999;
			if ( ( typeid ( * arrBase [ i ] ) == typeid ( Square ) )
				&& ( typeid ( * arrBase [ j ] ) == typeid ( Square ) ) )
			    temp = arrBase [ i ] -> getPoint (). delta ( arrBase [ j ] -> getPoint () );
			if ( typeid ( * arrBase [ i ] )  == typeid ( Circle )
				&& typeid ( * arrBase [ j ] ) == typeid ( Circle ) )
			    temp = arrBase [ i ] -> getPoint (). Hypotenus ( arrBase [ j ] -> getPoint () );
			if ( temp < minSize )
				minSize = temp ;
		}

	Base :: setSize ( minSize );
	for ( i = 0; i < N ; i ++ )
   	if ( typeid ( * arrBase [ i ] ) == typeid ( Square ) )
      		dynamic_cast < Square * > ( arrBase [ i ] ) -> print ();
      	else
       		dynamic_cast < Circle * > ( arrBase [ i ] ) -> print ();

 	for ( i = 0; i < N ; i ++ )
		delete arrBase [ i ];
}
