//  For Visual C++
#include <iostream.h>
#include <stdarg.h>

class Fraction {
	int num;
	unsigned denom;
public:
	Fraction ( int n = 0, unsigned d = 1 ) { num = n ; denom = d ; }
	friend ostream & operator << ( ostream & , const Fraction & );
};
ostream & operator << ( ostream & s , const Fraction & temp )
{
	s << temp . num << " / " << temp. denom;
	return s ;
}

template <class T>
T * toArray ( unsigned nElements , T firstElement , ... )
{
	T * pArray ;
	va_list myArguments;
	va_start ( myArguments, firstElement );
	pArray = new T [ nElements ] ;
	if ( pArray == NULL )
		return NULL ;
	pArray [ 0 ] = firstElement ;
	for ( unsigned i = 1 ; i < nElements ; i ++ )
		pArray [ i ] = va_arg ( myArguments , T );
	va_end ( myArguments );
	return pArray ;
}

void main ( void )
{
	int * pArrInt , i ;
	pArrInt = toArray ( 5 , 100 , 200 , 300 , 400 , 500 );
	if ( pArrInt == NULL )
		return ;
	for ( i = 0 ; i < 5 ; i ++ )
		cout <<  pArrInt [ i ] << "  ";
	cout << endl ;
	delete [ ] pArrInt ;

	char ** pArrStrings = toArray ( 3 , "abcdef", "g",  "hij" );
	if ( pArrStrings == NULL )
		return ;
	for ( i = 0 ; i < 3 ; i ++ )
		cout <<  pArrStrings [ i ] << "  ";
	cout << endl ;
	delete [ ] pArrStrings ;

	Fraction * pArrFractions = toArray ( 4 , Fraction ( 7, 8 ), Fraction ( -3 ),
		Fraction ( 5, 2 ) , Fraction ( 1, 2 ) ) ;

	if ( pArrFractions == NULL )
		return ;
	for ( i = 0 ; i < 4 ; i ++ )
		cout <<  pArrFractions [ i ] << "  ";
	cout << endl ;
	delete [ ] pArrFractions ;
}
