#include <iostream.h>		// Template class Vector < Fraction >

class Fraction {
	int num;
	unsigned denom;
public:
	Fraction ( int n = 0, unsigned d = 1 ) : num ( n ), denom ( d ) { }
	Fraction operator + ( const Fraction & A ) const {
		return Fraction ( num * A.denom + denom * A.num , denom * A.denom );
	}
	Fraction operator * ( const Fraction & A ) const {
		return Fraction ( num * A.num , denom * A.denom );
	}
	bool operator> ( const Fraction & A ) const {
		return num * ( signed ) A.denom > ( signed ) denom * A.num ;
	}
	friend ostream & operator << ( ostream & , const Fraction & );
};
ostream & operator << ( ostream & s , const Fraction & temp )
{
	s << temp . num << " / " << temp. denom;
	return s ;
}

template < class T >
class Vector {
	T x, y, z;
public :
	Vector ( ) { }
	Vector ( T xx, T yy, T zz ) : x ( xx ), y ( yy ) , z ( zz ) { }
	bool operator > ( const Vector & ) const ;  // Length compare
	friend ostream & operator << ( ostream & , const Vector & );
};

template < class T >
bool Vector < T > :: operator > ( const Vector < T > & A ) const
{
	return  x * x + y * y + z * z > A.x * A.x + A.y * A.y + A.z * A.z;
}

template < class T >
ostream & operator<< ( ostream & s, const Vector < T > & temp )
{
	s << "{ " << temp.x << ", " << temp.y << ", " << temp.z << " }";
	return s ;
}

template < class T >
int maxElement ( const Vector < T > arr [ ] , int size )
{
	int i, indexMax = 0;
	for ( i = 1 ; i < size ; i ++ )
		if ( arr [ i ] > arr [ indexMax ] )
			indexMax = i;
	return indexMax ;
}

void main ( )
{
	Vector < int > arrVectorInt [ 5 ] = { Vector < int > ( 3, -2, 6 ),
		Vector < int > ( 34, -23, 18 ), Vector < int > ( 4, 3, -8 ),
		Vector < int > ( -5, -3, -8 ),  Vector < int > ( 8, 3, 4 ) };
	int  indexMax = maxElement ( arrVectorInt , 5 );
	cout << "Max Vector ( integer )  " << arrVectorInt [ indexMax ] << endl;

	Fraction F1 ( 1, 2 ), F2 ( -31, 4 ), F3 ( 5, 6 ), F4 ( 25, 3 ), F5 ( -18, 3 ),
		F6 ( 17, 2 ), F7 ( 5, 8 ), F8 ( -12 , 4 ), F9 ( 21, 7 );
	Vector < Fraction > arrVectorFraction [ 3 ] = { Vector < Fraction > ( F1, F2, F3 ),
		Vector < Fraction > ( F4, F5, F6 ), Vector < Fraction > ( F7, F8, F9 ) };
	indexMax = maxElement ( arrVectorFraction , 3 );
	cout << "Max Vector ( Fraction )  " << arrVectorFraction [ indexMax ] << endl;
}
