#include <iostream.h>                      // TEMPLATE CLASS "ARRAY"
#include <stdarg.h>			   // CONSTRUCTOR ( int, ... )

class Fraction {
	int num;
	unsigned denom;
public: Fraction ( int n = 0, unsigned  d = 1 ) : num ( n ), denom ( d ) { }
	void operator += ( const Fraction & A ) {
		num = num * A.denom + denom * A.num ;  denom *=  A.denom ;
	}
	friend ostream & operator << ( ostream & , const Fraction & );
};
ostream & operator<< ( ostream & s, const Fraction & temp )
{       s << temp.num << " / " << temp.denom;
	return s ;
}

template < class T > class Array {
	unsigned size;
	T * pT ;
public: Array ( unsigned s = 0, const T * = NULL ) ;
	Array ( unsigned , ... );
	Array ( const Array & );
	~Array () { if ( size ) delete [] pT ; }
	T & operator[] ( unsigned index ) { return pT [ index ]; }
	Array operator + (  const Array  & ) const;
	Array & operator= ( const Array  & );
	friend ostream & operator << ( ostream & , const Array & );
};

template <class T>
Array <T> :: Array ( unsigned s, const T * newT ) : size ( s )
{
	if ( size ) {
		pT = new T [ size ];
		if ( newT )
			for ( unsigned i = 0; i < size; i ++ )
				pT [ i ] = newT [ i ];
		else
			for ( unsigned i = 0; i < size; i ++ )
				pT [ i ] = T ( );
	}
}
template <class T>
Array <T> :: Array ( unsigned s, ... ) : size ( s )
{
	pT = new T [ s ];
	va_list ap;
	va_start ( ap , s );
	for ( unsigned i = 0 ;  i < s ; i ++ )
		pT [ i ] = va_arg ( ap , T );
	va_end ( ap );
}
template <class T>
Array <T> :: Array ( const Array <T> & arr2 ) : size ( arr2.size )
{
	pT = new T [ size ];
	for ( unsigned i = 0; i < size ; i++)
		pT [ i ] = arr2 [ i ];
}

template <class T>
Array <T> & Array <T> :: operator= ( const Array <T> & arr2 )
{	if ( size != arr2.size ) {
		if ( size )
			delete [ ] pT ;
		size = arr2.size;
		pT = new T [ size ];
	}
	for ( unsigned i = 0; i < size ; i++)
		pT [ i ] = arr2 [ i ];
	return * this;
}
template <class T>
Array <T> Array <T> :: operator+ ( const Array <T> & arr2 ) const
{
	Array temp;
	if ( size > arr2.size ) {
		temp = * this ;
		for ( unsigned i = 0; i < arr2.size ; i++ )
			temp [ i ] += arr2 [ i ];
	}
	else {
		temp = arr2 ;
		for ( unsigned i = 0; i < size ; i++ )
			temp [ i ] += ( * this ) [ i ];
	}
	return temp;
}

template <class T>
ostream & operator << ( ostream & s , const Array <T> & temp )
{	s << "{ ";
	for ( unsigned i = 0; i < temp.size ; i++)
		s << temp [ i ] << "  ";
	s << "\b}";
	return s;
}

void main ( void )
{
	int dataInt [ 3 ] = { 1, 2, 3 };
	Array <int> arrInt1 ( 3, dataInt ),
		   arrInt2 ( 5, 100, 200, 300, 400, 500 ), arrInt3 ;
	arrInt3 = arrInt1 + arrInt2;
	cout << arrInt1 << " + " << arrInt2 << " = " << arrInt3 << endl;

	Fraction dataFraction [ 2 ] = { Fraction ( 1, 2 ), Fraction ( 1 , 3 ) };
	Array <Fraction>  arrFract1 ( 2, dataFraction ),
	       arrFract2 ( 3, Fraction (1, 4), Fraction(1, 5), Fraction(1, 6) );
	cout << arrFract1 << " + " << arrFract2 << " = " << arrFract1 + arrFract2;
}
