#include <iostream.h>                     
#include <stdarg.h>			   

template < class T > class Array {
	unsigned size;
	T * pT ;
public: Array ( unsigned s = 0, const T * = NULL ) ;
	Array ( unsigned , ... );
	Array (  const Array & );
	~Array () { if ( size ) delete [] pT ; }
	T & operator[] ( unsigned index ) { return pT [ index ]; }
	Array & operator= (  const Array  & );
	friend ostream & operator << ( ostream & , const Array & );
};

template <class T>
Array <T> :: Array ( unsigned s,  const T * newT ) : size ( s )
{
	if ( size ) {
		pT = new T [ size ];
		if ( newT )
			for ( unsigned i = 0; i < size; i ++ )
				pT [ i ] = newT [ i ];
		else
			for ( unsigned i = 0; i < size; i ++ )
				pT [ i ] = T ( );
	}
}
template <class T>
Array <T> :: Array ( unsigned s, ... ) : size ( s )
{
	pT = new T [ s ];
	va_list ap;
	va_start ( ap , s );
	for ( unsigned i = 0 ;  i < s ; i ++ )
		pT [ i ] = va_arg ( ap , T );
	va_end ( ap );
}
template <class T>
Array <T> :: Array ( const Array <T> & arr2 ) : size ( arr2.size )
{
	pT = new T [ size ];
	for ( unsigned i = 0; i < size ; i++)
		pT [ i ] = arr2 [ i ];
}

template <class T>
Array <T> & Array <T> :: operator= ( const Array <T> & arr2 )
{	if ( size != arr2.size ) {
		if ( size )
			delete [ ] pT ;
		size = arr2.size;
		pT = new T [ size ];
	}
	for ( unsigned i = 0; i < size ; i++)
		pT [ i ] = arr2 [ i ];
	return * this;
}

template <class T>
ostream & operator << ( ostream & s , const Array <T> & temp )
{	s << "{ ";
	for ( unsigned i = 0; i < temp.size ; i++)
		s << temp [ i ] << "  ";
	s << "\b}";
	return s;
}

void main ( void )
{
	int dataInt_1 [ 3 ] = { 1, 2, 3 }, dataInt_2 [ 5 ] = { 4, 5, 6 , 7, 8 } ;
	Array <int> arrInt1 ( 3, dataInt_1 ), arrInt2 ( 5, dataInt_2 ) ,
		    arrInt3 ( 3, 10, 20, 30 ), arrInt4 ( 4, 40, 50, 60 , 70 );

							// Ellipses
	Array < Array <int> > matrix_1 ( 4 , arrInt1, arrInt2, arrInt3, arrInt4 );
	cout << matrix_1 << endl;

	for ( int i = 0; i < 4; i ++ )
		matrix_1 [ i ][ i ] = - 99;           // operator [ ]
	cout << matrix_1 << endl ;

	Array <int> dataArrArr [ 3 ] = { arrInt2, arrInt3, arrInt4 };
	Array < Array <int> > matrix_2 ( 3 , dataArrArr );
	matrix_1 = matrix_2;                          // opearator =
	cout << matrix_1 << endl ;
}
