#include <iostream.h>

#define N 4

class Fraction {
	int num;
	unsigned denom;
public:	Fraction ( int n = 0, int d = 1 ) : num ( n ), denom ( d ) { }
	Fraction operator * ( Fraction second) const {
		return Fraction ( num * second.num, denom * second.denom );
	}
	bool operator > ( const Fraction & second) const {
		return num * ( signed ) second.denom > ( signed ) denom * second.num ;
	}
	bool operator == ( const Fraction & second) const {
		return num * second.denom == denom * second.num ;
	}
	friend ostream & operator<< ( ostream & , const Fraction & );
};
ostream & operator<< ( ostream & s, const Fraction & temp )
{
	s << temp.num << " / " << temp.denom;
	return s ;
}

template < class T > class Base {
protected:
	T vertexX , vertexY ;
	T firstLength;
	Base ( T vX, T vY, T fL ) : vertexX ( vX ), vertexY ( vY ),
		firstLength ( fL ) { }
public:  virtual void print () const = 0 ;
	 T firstLengthOut ( ) const { return firstLength; }
	 virtual T secondLengthOut ( ) const = 0;
	 T area () const { return firstLengthOut () * secondLengthOut() ;}
};

template < class T > class Rectangle : public Base < T > {
	T secondLength;
public:	Rectangle ( T vX, T vY, T fL, T sL ): Base < T > ( vX, vY, fL ) {
		secondLength = sL ; }
	void print () const { cout << "\nRectangle :  Vertex { " << vertexX << " , "
		<< vertexY << " } , Sides { " <<  firstLength << " , " <<
		secondLength << " } " ; }
	T secondLengthOut ( ) const { return secondLength ;}
};

template < class T > class Square : public Base < T > {
public:	Square ( T vX, T vY, T fL ): Base < T > ( vX, vY, fL ) { }
	void print () const { cout << "\nSquare :  Vertex { " << vertexX << " , "
		<< vertexY << " } , side  " <<  firstLength ; }
	T secondLengthOut ( ) const { return firstLength ;}
};

void main ( void )
{
	Rectangle < int > RectInt_1 ( 1, 2, 3 ,4 ), RectInt_2 ( 2, 0, 5, 5 );
	Square < int > SquarInt_1 ( 3, 4, 2 ),  SquarInt_2 ( 7, 9, 4 ) ;
	Base < int > * arrPBaseInt [ N ] = { & RectInt_1, & SquarInt_1,
		& SquarInt_2, & RectInt_2 };

	Rectangle < Fraction >
		RectFract_1 ( Fraction ( 8, 2 ), Fraction ( 0, 7 ),
			Fraction ( 1, 2 ), Fraction ( 3, 4 ) ) ,
		RectFract_2 ( Fraction ( 1, 2 ), Fraction ( 5, 6 ),
			Fraction ( 9, 1 ), Fraction ( 9, 1 ) ) ;
	Square < Fraction >
		SquarFract_1 ( Fraction ( 7, 3 ), Fraction ( 2, 5 ),
			Fraction ( 5, 2 ) ),
		SquarFract_2 ( Fraction ( 1, 3 ), Fraction ( 2, 7 ),
			Fraction ( 6, 3 ) ) ;
	Base < Fraction > * arrPBaseFract [ N ] = { & RectFract_1, & SquarFract_1,
		& SquarFract_2, & RectFract_2 };

	int i;
	cout << "\nAll Rectangles and Squares ( Fraction )" ;
	for ( i = 0; i < N ; i ++ )
		arrPBaseFract [ i ] -> print ();

	cout << "\n\nAll Squares ( integer )" ;
	for ( i = 0; i < N ; i ++ )
		if ( arrPBaseInt [ i ] -> firstLengthOut () ==
		     arrPBaseInt [ i ] -> secondLengthOut () )
			arrPBaseInt [ i ] -> print ();

	int indexMax = 0 ;
	for ( i = 1 ; i < N ; i ++ )
		if ( arrPBaseFract [ i ] -> firstLengthOut () ==
		     arrPBaseFract [ i ] -> secondLengthOut () &&
		     arrPBaseFract [ i ] -> area () >
		     arrPBaseFract [ indexMax ] -> area () )
			indexMax = i;

	cout << "\n\nMax Area Square ( Fraction ) : " ;
		arrPBaseFract [ indexMax ] -> print ();
}
