#include <typeinfo.h>
#include <iostream.h>

#define N 8

class Fraction {
	int num;
	unsigned  denom;
public:	Fraction ( int n = 0, int d = 1 ) : num ( n ), denom ( d ) { }
	void operator += ( const Fraction & second ) {
		num = num * second.denom + denom * second.num;
      	denom *= second.denom;
	}
	friend ostream & operator<< ( ostream & , const Fraction & );
};
ostream & operator<< ( ostream & s, const Fraction & temp )
{
	s << temp.num << " / " << temp.denom;
   	return s ;
}

class Complex {
	int real, image;
public: Complex ( int r = 0, int i = 0 ) : real ( r ), image ( i ) { }
	void operator += ( const Complex & second){
		real += second.real; image += second.image ;
	}
	friend ostream & operator<< ( ostream & , const Complex & );
};
ostream & operator<< ( ostream & s, const Complex & temp )
{
	s << temp.real << " + i * " << temp.image;
   	return s ;
}

class A {
public :  virtual ~ A () {}
};

template < class X > class B : public A {
	X x;
public: B () { }
	B ( X xx ) : x ( xx ) { }
	void operator += ( const B & b ) { x += b.x; }
	friend ostream & operator<< ( ostream & , const B & );
};
template < class X >
ostream & operator<< ( ostream & s, const B <X > & temp )
{
	s << temp.x << endl;
	return s ;
}


void main ( void )
{
	B < int > BInt_1 ( 1 ), BInt_2 ( 2 ), BInt_3 ( 3 ), BInt_Result ( 0 ) ;
	B < Fraction > BFract_1 ( Fraction ( 1, 2 )),BFract_2 ( Fraction ( 3 , 4 )),BFract_Result ;
	B < Complex > BCompl_1 ( Complex ( 1, 2 )),BCompl_2 ( Complex ( 3 , 4 )),BCompl_3( Complex ( 5 , 6 )), BCompl_Result ;

	A * arr_pA [ N ] = { &  BInt_1 ,& BFract_1 , & BCompl_1 ,
		&  BInt_2 ,& BFract_2 , & BCompl_2 ,&  BInt_3 , & BCompl_3 };
	
	for ( int i = 0 ; i < N ; i ++ ) {
		if ( typeid ( * arr_pA [ i ] ) == typeid ( B < int >  ))
			cout << * dynamic_cast < B < int > * > ( arr_pA [ i ] );
		if ( typeid ( * arr_pA [ i ] ) == typeid ( B < Fraction >  ))
			cout <<  * dynamic_cast < B < Fraction > * > ( arr_pA [ i ] );
		if ( typeid ( * arr_pA [ i ] ) == typeid ( B < Complex >  ))
			cout <<  * dynamic_cast < B < Complex > * > ( arr_pA [ i ] );
   	}

	for ( i = 0 ; i < N ; i ++ ) {
		if ( typeid ( * arr_pA [ i ] ) == typeid ( B < int >  ))
			BInt_Result += * dynamic_cast < B < int > * > ( arr_pA [ i ] );
		if ( typeid ( * arr_pA [ i ] ) == typeid ( B < Fraction >  ))
			BFract_Result += * dynamic_cast < B < Fraction > * > ( arr_pA [ i ] );
		if ( typeid ( * arr_pA [ i ] ) == typeid ( B < Complex >  ))
			BCompl_Result += * dynamic_cast < B < Complex > * > ( arr_pA [ i ] );
	}
	cout << "\nSun INT : " <<  BInt_Result;
	cout << "\nSun FRACTION : " <<  BFract_Result;
	cout << "\nSun COMPLEX : " <<  BCompl_Result;
}
