#include <typeinfo.h>
#include <iostream.h>

#define N 6

class Fraction {
	int num;
	unsigned  denom;
public:	Fraction ( int n = 0, int d = 1 ) : num ( n ), denom ( d ) { }
	void operator += ( const Fraction & second ) {
		num = num * second.denom + denom * second.num;
      	denom *= second.denom;
	}
	friend ostream & operator<< ( ostream & , const Fraction & );
};
ostream & operator<< ( ostream & s, const Fraction & temp )
{
	s << temp.num << " / " << temp.denom;
   	return s ;
}

class Complex {
	int real, image;
public: Complex ( int r = 0, int i = 0 ) : real ( r ), image ( i ) { }
	void operator += ( const Complex & second){
		real += second.real; image += second.image ;
	}
	friend ostream & operator<< ( ostream & , const Complex & );
};
ostream & operator<< ( ostream & s, const Complex & temp )
{
	s << temp.real << " + i * " << temp.image;
   	return s ;
}

class A {
public :  virtual ~ A () {};
};

template < class X > class B : public A {
protected:	X x;
public: B () { }
	B ( X xx ) : x ( xx ) { }
};

template < class X, class Y > class C : public B < X > {
	Y y;
public: C () { }
	C ( X xx, Y yy ) : B <X> (xx ){ y = yy ; }
	void operator += ( const C & c ) {
		x += c.x;
		y += c.y;
	}
	friend ostream & operator<< ( ostream & , const C & );
};
template < class X, class Y >
ostream & operator<< ( ostream & s, const C < X , Y > & temp )
{
	s << temp.x << "  " << temp.y << endl;
	return s ;
}

void main ( void )
{
	C < int , Fraction > CIntFract_1 ( 1, Fraction ( 1, 2 ) ),
		CIntFract_2 ( 2, Fraction ( 3, 4 ) ),
		CIntFract_3 ( 3, Fraction ( 5, 6 ) ), CIntFract_Result ( 0, Fraction ( ) ) ;

	C < double , Complex > CDoubleCompl_1 ( 1.11111 , Complex ( 1, 2 ) ),
		CDoubleCompl_2 ( 2.22222 , Complex ( 3, 4 )),
		CDoubleCompl_3 ( 3.33333 , Complex ( 5, 6 )), CDoubleCompl_Result ( 0, Complex ( )) ;

	A * arr_pA [ N ] = { &  CIntFract_1 ,& CIntFract_2 , & CDoubleCompl_1 ,
		&  CIntFract_3 ,& CDoubleCompl_2 , & CDoubleCompl_3 };

	for ( int i = 0 ; i < N ; i ++ ) {
	if ( typeid ( * arr_pA [ i ] ) == typeid ( C < int, Fraction >  ))
		cout << * dynamic_cast < C < int, Fraction > * > ( arr_pA [ i ] );
		if ( typeid ( * arr_pA [ i ] ) == typeid ( C < double, Complex >  ))
		cout << * dynamic_cast < C < double, Complex > * > ( arr_pA [ i ] );
	}

	for ( i = 0 ; i < N ; i ++ ) {
		if ( typeid ( * arr_pA [ i ] ) == typeid ( C < int, Fraction >  ))
			CIntFract_Result += * dynamic_cast < C < int, Fraction > * > ( arr_pA [ i ] );
		if ( typeid ( * arr_pA [ i ] ) == typeid ( C < double, Complex >  ))
			CDoubleCompl_Result += * dynamic_cast < C < double, Complex > * > ( arr_pA [ i ] );
	}
	cout << "\nSun int_Fraction : " <<  CIntFract_Result;
	cout << "\nSun double_Complex : " <<  CDoubleCompl_Result;
}
