#include <iostream.h> 
#include <math.h>                    

class Fraction {
	short num;
	unsigned short denom;
public: Fraction ( short n = 0, unsigned short d = 1 ) : num ( n ), denom ( d ) { }
	Fraction operator + ( const Fraction & A )  const {
		return Fraction (  num * A.denom + denom * A.num ,  denom *  A.denom );
	}
	operator float () const { return ( float ) num / denom; }
	friend ostream & operator << ( ostream & , const Fraction & );
};
ostream & operator<< ( ostream & s, const Fraction & temp )
{       s << temp.num << " / " << temp.denom;
	return s ;
}

template < class T >
T sum ( T a, T b )
{	T result = a + b;
	if ( fabs ( float ( a ) + float ( b ) - float ( result ) ) > 0.001 )
				throw ( a );
	return result ;
}

void main ( void )
{	
	try {
		short int_A = 32000, int_B = -31000 , int_C = -32000  ;
		cout << int_A << " + " << int_B << " = " 
			 << sum ( int_A , int_B ) << endl ;
		cout << int_B << " + " << int_C << " = " 
			 << sum ( int_B , int_C ) << endl ;
	}
	catch ( short ) {
		cout << "Overflow ( int )\n";
	}

	try {
		Fraction Fraction_A( 1, 2 ), Fraction_B ( 1 , 10 ) , Fraction_C ( 32000 , 1 ) ;
		cout << Fraction_A << " + " << Fraction_B << " = " 
			 << sum ( Fraction_A , Fraction_B ) << endl ;
		cout << Fraction_B << " + " << Fraction_C << " = " 
			 << sum ( Fraction_B , Fraction_C ) << endl ;
	}
	catch ( Fraction ) {
		cout << "Overflow ( Fraction )\n";
	}
}
