#include <iostream.h>
#include <stdarg.h>
#include <math.h>
#include <string.h>

bool remainderIsZero ( int a , int b )
{
	if ( b == 0 )
		throw ( b );
	return a % b == 0 ;
}

bool remainderIsZero ( double a , double b )
{
	if ( fabs ( b ) < 0.000001 )
		throw ( b );
	return fabs ( a / b - ( int ) ( a / b ) ) < 0.000001 ;
}

bool remainderIsZero ( const char * a , const char * b )
{
	if ( strlen ( b ) == 0 )
		throw ( b );
	char * pTemp ;
	while ( * a ) {
		pTemp = strstr ( a, b );
		if ( pTemp == a )
			a += strlen ( b );
		else  break ;
	}
	return * a == 0 ;
}

template <class T>
T * toArray ( unsigned n , unsigned & resultSize , T firstElement , ... )
{
	T * pArray , tempT ;
	pArray = new T [ n ] ;
	if ( pArray == NULL )
		throw ( pArray ) ;
	pArray [ 0 ] = firstElement ;
	va_list myArguments;
	va_start ( myArguments, firstElement );
	unsigned counter = 1, i;
	for ( i = 1 ; i < n ; i ++ ) {
		tempT = va_arg ( myArguments , T );
		try {
			if ( remainderIsZero ( firstElement , tempT ) )
				pArray [ counter ++ ] = tempT ;
		}
		catch ( ... ) {
			delete [ ] pArray ;
			throw ( tempT ) ;
		}
	}
	resultSize = counter ;
	return pArray ;
}

void main ( void )
{	
	unsigned i , size;
	try {
		int * pArrInt = toArray ( 5 , size, 100 , 10 , 7 , 20 , 17 );
		for ( i = 0 ; i < size ; i ++ )
			cout <<  pArrInt [ i ] << "  ";
		cout << endl ;				//  Output  100  10  20
		delete [ ] pArrInt ;
	}
	catch ( int * ) { cout << "Memory Allocation Error ( int )\n"; }
	catch ( int )   { cout << "Divide to Zero ( int )\n"; }

	try {
		double * pArrDouble = toArray ( 4 , size, 25.0, 0.25, 0.000005, 0.0000000001 );
		for ( i = 0 ; i < size ; i ++ )
			cout <<  pArrDouble [ i ] << "  ";
		cout << endl ;		
		delete [ ] pArrDouble ;
	}				// Output  Divede to Zero ( double )
	catch ( double * ) { cout << "Memory Allocation Error ( double )\n";}
	catch ( double )   { cout << "Divide to Zero ( double )\n"; }

	try {
		char ** pArrStrings = toArray ( 4, size, "abababab", "a", "ab" ,"abab");
		for ( i = 0 ; i < size ; i ++ )
			cout <<  pArrStrings [ i ] << "  ";
		cout << endl ;		// Output  abababab  ab  abab
		delete [ ] pArrStrings ;
	}
	catch ( char ** ) { cout << "Memory Allocation Error ( String )\n";}
	catch ( char * )  { cout << "Divide to Zero ( String )\n"; }
}
