#include <iostream.h>                      // CLASS "FRACTION"

class Fraction {
	int numerat;
	unsigned int denomirat;
public:
	Fraction ( int num = 0, unsigned int denom = 1 ) {
		if ( denom == 0 ) 
			throw ( "Zero in Fraction denomirat");
		numerat = num ; denomirat = denom ;
	}
	Fraction operator + ( const Fraction & ) const;
	Fraction operator - ( const Fraction & ) const;
	Fraction operator * ( const Fraction & ) const;
	Fraction operator / ( const Fraction & ) const;
	friend ostream & operator << ( ostream & , const Fraction & );
};
istream & operator >> ( istream & , Fraction & );

ostream & operator << ( ostream & s , const Fraction & temp )
{     		
	s << temp.numerat << " / " << temp.denomirat;
	return s ;
}

istream & operator >> ( istream & s , Fraction & temp )
{      	int num ;
	unsigned int den ;
	char sign ;
	s >> num >> sign >> den;
	temp = Fraction ( num , den );
	return s ;
}

Fraction  Fraction :: operator + ( const Fraction & secondFraction ) const
{       return Fraction ( numerat * secondFraction.denomirat + denomirat * secondFraction.numerat,
			  denomirat * secondFraction.denomirat );
}

Fraction  Fraction :: operator - ( const Fraction & secondFraction ) const
{       return * this + Fraction ( -secondFraction.numerat, secondFraction.denomirat );
}

Fraction Fraction :: operator * ( const Fraction & secondFraction ) const
{       return Fraction ( numerat * secondFraction.numerat ,
			  denomirat * secondFraction.denomirat );
}

Fraction Fraction :: operator / ( const Fraction & secondFraction ) const
{   if ( secondFraction.numerat == 0 )
		throw ( "Divide to Zero Fraction" );    
	return Fraction ( numerat * secondFraction.denomirat ,
			  denomirat * secondFraction.numerat );
}

class ComplexOfFractions {
	Fraction  real , image ;
public:
	ComplexOfFractions ( int = 0, int = 1, int = 0, int = 1 ) ;
	ComplexOfFractions ( const Fraction & , const Fraction &) ;
	ComplexOfFractions operator + ( const ComplexOfFractions & ) const;
	ComplexOfFractions operator - ( const ComplexOfFractions & ) const;
	ComplexOfFractions operator * ( const ComplexOfFractions & ) const;
	ComplexOfFractions operator / ( const ComplexOfFractions & ) const;
	friend ostream & operator << ( ostream & , const ComplexOfFractions & );
};
istream & operator >> ( istream & , ComplexOfFractions & );

ostream & operator << ( ostream & s , const ComplexOfFractions & temp )
{
	s << temp.real << " + i * " << temp.image;
	return s ;
}

istream & operator >> ( istream & s , ComplexOfFractions & temp )
{       Fraction r, i;
	s >> r >> i;
	temp = ComplexOfFractions ( r, i );
	return s ;
}

ComplexOfFractions :: ComplexOfFractions ( int i1 , int i2 , int i3 , int i4 )
{
	try {
		real = Fraction( i1, i2 );
		image = Fraction ( i3,i4 );
	}
	catch ( char * mess ) {
		throw ( mess );
	}
}

ComplexOfFractions :: ComplexOfFractions ( const Fraction & F1, const Fraction & F2 ) 
	: real ( F1 ) , image ( F2 )
{
}

ComplexOfFractions  ComplexOfFractions :: operator + ( const ComplexOfFractions & second ) const
{
	return ComplexOfFractions ( real + second.real, image + second.image );
}

ComplexOfFractions  ComplexOfFractions :: operator - ( const ComplexOfFractions & second ) const
{
	return ComplexOfFractions ( real - second.real, image - second.image );
}

ComplexOfFractions ComplexOfFractions :: operator * ( const ComplexOfFractions & second ) const
{
	return ComplexOfFractions ( real * second.real - image * second.image ,
		  real * second.image + real * second.image );
}

ComplexOfFractions ComplexOfFractions :: operator / ( const ComplexOfFractions & second ) const
{
	Fraction temp = second.real * second.real + second.image * second.image ;
	try {
		Fraction resultReal = ( real * second.real + image * second.image ) / temp;
		Fraction resultImage = ( real * second.image - real * second.image) / temp;
		return ComplexOfFractions ( resultReal , resultImage );
	}
	catch ( char * mess ) {
		throw ( mess );
	}
}

void main ( void )
{
	
	try {
		Fraction DataFraction_1 ( 1, 2 ), DataFraction_2 ( 3 , 4 );
		ComplexOfFractions A ( 5, 6, 7, 8 ), B ( DataFraction_1, DataFraction_2 ), C ;

		cout << A << "  +  " << B << "  =  " << A + B << endl ;
		cout << A << "  -  " << B << "  =  " << A - B << endl ;
		cout << A << "  *  " << B << "  =  " << A * B << endl ;

		ComplexOfFractions D ( 1, 1, 1, 1 ), E ( 0, 1, 0, 1 );
		cout << D << "  /  " << E << "  =  " << D / E << endl ;
		
		cout << "Put two Fractions in form  # / #  \n" ;
		cin >> C ;
        cout << C ;
	}
	catch ( char * mess ) {
		cout << mess << endl;
	}

}