#include <iostream.h>                     
#include <stdarg.h>			   

class Fraction {
	short num;
	unsigned short denom;
public: Fraction ( short n = 0, unsigned short  d = 1 ) {
		if ( d == 0 )
			throw ( n );
		num = n ; denom = d;
	}
	Fraction operator + ( Fraction A ) {
		return Fraction (  num * A.denom + denom * A.num ,  denom *  A.denom );
	}
	friend float toFloat ( Fraction );
	friend ostream & operator << ( ostream & , const Fraction & );
};
float toFloat ( Fraction A)
{
	return ( float ) A.num / A.denom;
}
ostream & operator<< ( ostream & s, const Fraction & temp )	
{       s << temp.num << " / " << temp.denom;
	return s ;
}

float toFloat ( short A)
{
	return ( float ) A;
}

template < class T > class Array {
	unsigned size;
	T * pT ;
public: Array ( unsigned s = 0, T * = NULL ) ;
	Array ( unsigned , ... );
	Array ( Array & );
	~Array () { if ( size ) delete [] pT ; }
	T & operator[] ( unsigned index ) { 
		if ( index < 0 || index >= size )
			throw ( * pT ) ;
		return pT [ index ]; 
	}
	Array operator+ ( Array );
	Array & operator= ( Array  & );
	friend ostream & operator << ( ostream & , Array & );
};

template <class T>
Array <T> :: Array ( unsigned s, T * newT ) : size ( s )
{
	if ( size ) {
		pT = new T [ size ];
		if ( pT == NULL )
			throw ( pT ) ;
		if ( newT )
			for ( unsigned i = 0; i < size; i ++ )
				pT [ i ] = newT [ i ];
		else
			for ( unsigned i = 0; i < size; i ++ )
				pT [ i ] = T ( );
	}
}
template <class T>
Array <T> :: Array ( unsigned s, ... ) : size ( s )
{
	pT = new T [ size ];
	if ( pT == NULL )
		throw ( pT );

	va_list ap;
	va_start ( ap , s );
	for ( unsigned i = 0 ; i < s ; i ++ )
		try {
			pT [ i ] = va_arg ( ap , T );
		}
	catch ( short nn ) {
			throw ( nn );
		}
	va_end ( ap );
}

template <class T>
Array <T> :: Array ( Array <T> & arr2 ) : size ( arr2.size )
{
	pT = new T [ size ];
	if ( pT == NULL )
		throw ( pT ) ;
	for ( unsigned i = 0; i < size ; i++)
		pT [ i ] = arr2 [ i ];
}

template <class T>
Array <T> & Array <T> :: operator= (  Array <T> & arr2 )
{	if ( size != arr2.size ) {
		if ( size )
			delete [ ] pT ;
		size = arr2.size;
		pT = new T [ size ];
		if ( pT == NULL )
			throw ( pT ) ;
	}
	for ( unsigned i = 0; i < size ; i++)
		pT [ i ] = arr2 [ i ];
	return * this;
}
template <class T>
Array <T> Array <T> :: operator+ ( Array <T> arr2 )
{	
	Array temp;
	if ( size > arr2.size ) {
		temp = * this ;
		for ( unsigned i = 0; i < arr2.size ; i++ ) {
			if ( toFloat ( temp [ i ] ) + toFloat ( arr2 [ i ] ) 
				-  toFloat ( temp [ i ] + arr2 [ i ] )  > 0.001 )
				throw ( "Overflow" );
			temp [ i ] = temp [ i ] + arr2 [ i ];
		}
	}
	else {
		temp = arr2 ;
		for ( unsigned i = 0; i < size ; i++ ) {
			if ( toFloat ( temp [ i ] ) +  toFloat ( ( * this ) [ i ] )
				-  toFloat ( temp [ i ] + ( * this ) [ i ] )  > 0.001 )
				throw ( "Overflow" );
			temp [ i ] = temp [ i ] + ( * this ) [ i ];
		}
	}
	return temp;
}

template <class T>
ostream & operator << ( ostream & s , Array <T> & temp )
{	s << "{ ";
	for ( unsigned i = 0; i < temp.size ; i++)
		s << temp [ i ] << "  ";
	s << "\b}";
	return s;
}

void main ( void )
{	
	try {
		short dataInt [ 3 ] = { 10, 200, 30000 };
		Array <short> arrInt1 ( 3, dataInt ),
			   arrInt2 ( 5, 100, 2000, 30000, 4000, 500 ), arrInt3 ;
		arrInt3 = arrInt1 + arrInt2;
		cout << arrInt1 << " + " << arrInt2 << " = " << arrInt3 << endl;
		arrInt1 [ 3000 ] = 10;
	}
	catch  ( short * ) {
		cout << "\nMemory allocation error ( int )\n" ;
	}
	catch ( short ) {
		cout << "\nIndex  error ( int )\n";
	}
	catch ( char * mess ) {
		cout << mess << "   ( int )\n";
	}

	try {
		Fraction dataFraction [ 2 ] = { Fraction ( 1, 2 ), Fraction ( 1 , 3 ) };
		Array <Fraction>  arrFract1 ( 2, dataFraction ),
			arrFract2 ( 3, Fraction (1, 4), Fraction(1, 5), Fraction(1, 6) );
		cout << arrFract1 << " + " << arrFract2 << " = " << arrFract1 + arrFract2;
		arrFract1 [ 3 ] = Fraction ( 1 ,0 );   /// 1 / 0
	}
	catch  ( Fraction * ) {
		cout << "\nMemory allocation error ( Fraction )\n" ;
	}
	catch ( Fraction ) {
		cout << "\nIndex  error ( Fraction )\n";
	}
	catch ( char * mess ) {
		cout << mess << "   ( Fraction )\n";
	}
	catch ( short ) {
		cout << "\nZero Denominator\n";
	}
}
