/*	               Base  unsigned day
//	            /       |          \
//	          /         |            \
//	   Day_Month       Day_In_Year     Day_Week
//    unsigned month                  usigned week
*/
#include <iostream.h>

#define SIZE 6

unsigned daysInWonth [ 12 ] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
unsigned firstDayYear_In_Week = 4 ;

class Day_In_Year ;			// Pre - declaration

class Base {
protected: unsigned day ;
public: Base ( unsigned d = 1 ) { day = d ; }
	 virtual void print () const = 0 ;
	 virtual Day_In_Year operator ~ ( ) const = 0 ;
};

class Day_In_Year : public Base {
public:	Day_In_Year ( unsigned d = 1 ) : Base ( d ) {
		if ( d == 0 )
			throw "Zero Day In Year" ;
		if ( d > 365 )
			throw "Day In Year Too Big" ;
	}
	void print () const { cout << "Day_In_Year : day  " << day << endl ; 	}
	Day_In_Year operator ~ ( ) const { return * this; }
	bool operator == ( Day_In_Year second ) const {
		return day == second.day ;
	}
};

class Day_Month : public Base {
	unsigned month ;
public:	Day_Month ( unsigned d = 1 , unsigned m = 1 ) : Base ( d ) {
		if ( d == 0 )
			throw "Zero Day In Year" ;
		if ( d > daysInWonth [ m - 1 ] )
			throw "Day In Month Too Big" ;
		if ( m == 0 )
			throw "Zero Month" ;
		if ( m > 12 )
			throw "Month Too Big" ;
		month = m ;
	}
	void print () const { cout << "Day_Month : day  " << day << " , month  " <<
		month << endl ;
	}
	Day_In_Year operator ~ ( ) const ;
};

Day_In_Year Day_Month :: operator ~ ( )const 
{
	unsigned result = 0 ;
	for ( unsigned i = 0 ; i < month - 1 ; i ++ )
		result += daysInWonth [ i ] ;
	result += day ;
	return  Day_In_Year ( result ) ;
}

class Day_Week : public Base {
	unsigned week ;
public:	Day_Week ( unsigned d = 1 , unsigned w = 1 ) : Base ( d ) {
		if ( d == 0 )
			throw "Zero Day In Week" ;
		if ( d > 7 )
			throw "Day In Week Too Big" ;
		if ( w == 0 )
			throw "Zero Week" ;
		if ( w > 53 )
			throw "Week Too Big" ;
		week = w ;
	}
	void print () const { cout << "Day_Week : day  " << day << " , week  " <<
		week << endl ;
	}
	Day_In_Year operator ~ ( ) const {
		return  Day_In_Year ( day - firstDayYear_In_Week + 1 + 7 * ( week - 1 ) );
	}
};

void main ( void )
{

	try {
		Base * arrBase [ SIZE ] = {
			& Day_Week ( 7 , 40 ) , & Day_In_Year ( 271 ) ,
			& Day_Month ( 28 , 9 ) , & Day_In_Year ( 111 ) ,
			& Day_Week ( 6 , 40 ) , & Day_Month ( 4 , 10 )
		};

		for ( int i = 0 ; i < SIZE ; i ++ )
			for ( int j = i + 1 ; j < SIZE ; j ++ ) 
				if ( ~ ( * arrBase [ i ] ) == ~ ( * arrBase [ j ] )) {
					cout << "\nDate\t\t\t";
					arrBase [ i ] -> print () ;
					cout << "is equal to Date\t";
					arrBase [ j ] -> print () ;
				}
	}
	catch ( char * mesage ) {
		cout << mesage ;
	}
}