//  MERGE : Two Sorted Stacks
//  First stack :    2 -> 3 -> 5 -> 7 -> 8 -> 10 -> 11
//  Second stack :   1 -> 3 -> 4 -> 6 -> 7 -> 9
//  Result - First stack : 1 -> 2 -> 3 -> 4 -> 5 -> 6 -> 7 -> 8 -> 9 -> 10 -> 11
// 	     Second stack: Empty


#include <iostream.h>

class Stack {
	int info;
	Stack * next;
public: Stack ( int newInfo , Stack * newNext ) {
		info = newInfo;  next = newNext;
	}
	Stack * PUSH ( int );
	Stack * POP ();
	char infoOut () { return info ; }

	Stack * print ( ) ;
	Stack * merge ( Stack * );
};

Stack * Stack :: PUSH ( int newInfo )
{
	Stack * pTemp = new Stack ( newInfo, this );
	if ( pTemp == NULL )  {
		cout << "\nSTACK FULL\n";
		pTemp = this;
	}
	return pTemp ;
}

Stack * Stack :: POP ( )
{
	Stack * pTemp = this;
	if ( pTemp == NULL )  cout << "\nSTACK EMPTY";
	else {
		pTemp = pTemp -> next;
		delete  this ;
	}
	return  pTemp ;
}

Stack * Stack :: print ( )
{
	Stack * pTemp = NULL, * pTop = this ;
	while ( pTop ) {
		cout <<  pTop -> info << "  ";
		pTemp = pTemp -> PUSH ( pTop -> info );
		pTop = pTop -> POP ( );
	}
	while ( pTemp ) {
		pTop = pTop -> PUSH ( pTemp -> info );
		pTemp = pTemp -> POP ( );
	}
	return pTop ;
}

Stack * Stack :: merge ( Stack * pTop2 )
{
	Stack * pTemp1 = this , * pResult = NULL;
	while ( pTemp1 && pTop2 ) {
		if ( pTemp1 -> info > pTop2 -> info ) {
			pResult = pResult -> PUSH ( pTop2 -> info );
			pTop2 = pTop2 -> POP ( );
			continue;
		}
		if ( pTemp1 -> info == pTop2 -> info )
			pTop2 = pTop2 -> POP ( );
		pResult = pResult -> PUSH ( pTemp1 -> info );
		pTemp1 = pTemp1 -> POP ( );
	}
	while ( pTemp1 ) {
		pResult = pResult -> PUSH ( pTemp1 -> info );
		pTemp1 = pTemp1 -> POP ( );
	}
	while ( pTop2 ) {
		pResult = pResult -> PUSH ( pTop2 -> info );
		pTop2 = pTop2 -> POP ( );
	}

	while ( pResult ) {
		pTemp1 = pTemp1 -> PUSH ( pResult -> info );
		pResult = pResult -> POP ( );
	}
	return pTemp1;
}

void main ()
{

	Stack * pTop1 = NULL, * pTop2 = NULL ;
	int firstArr [ 7 ] = { 2, 3, 5, 7, 8, 10, 11 }, * pF = & firstArr [ 6 ],
	    secondArr [ 6 ] = { 1, 3, 4, 6, 7, 9 }, * pS = & secondArr [ 5 ];

	while ( pF >= firstArr )
		pTop1 = pTop1 -> PUSH ( * pF -- );
	while ( pS >= secondArr )
		pTop2 = pTop2 -> PUSH ( * pS -- );

	cout << "\nFirst stack : " ;
	pTop1 = pTop1 -> print ( );
	cout << "\nSecond stack : ";
	pTop2 = pTop2 -> print ( );

	pTop1 = pTop1 -> merge ( pTop2 );
	pTop2 = 0;
	cout << "\nFirst stack : ";
	pTop1 = pTop1 -> print ( );

	while ( pTop1 )
		pTop1 = pTop1 -> POP();
}