#include <iostream.h>

#define STOP 11111

class	Tree {
	int info ;
	Tree * left , * right;
public: Tree ( int nInfo = 0, Tree * nLeft = NULL, Tree * nRight = NULL) {
		info = nInfo; left = nLeft; right = nRight;}
	~Tree () {}
	int infoOut () { return info ; }
	Tree * additionElement ( int );
	void deleteTree ();
	void InorderPrint ( );

	unsigned int branchCounter ( unsigned int );
	Tree * maxBalanced ( unsigned int & );

};

Tree * Tree :: additionElement ( int newInfo )
{       Tree * current = this;
	if ( this == NULL )  {                   	     // first element
		current =  new Tree  ( newInfo , 0, 0 );
		return  current;
	}
	while ( 1 ) {			     // search place for new element
		if ( newInfo < current -> info && current -> left )
			current  = current -> left;
		else  if ( newInfo > current -> info && current->right )
			current = current -> right;
		    else  if ( newInfo == current -> info ) {
				cout << newInfo << "  ALREADY EXIST IN TREE\n";
				return this;
			  }
			  else break;
	}
	if ( newInfo < current -> info ) {
		current -> left =  new Tree  ( newInfo , 0, 0 );
		if ( ! current -> left )  cout << "MEMORY FULL\n";
	}  else {
		current -> right = new Tree  ( newInfo , 0, 0 );
		if ( ! current -> right ) cout << "MEMORY FULL\n";
	}
	return this;
}
void Tree :: deleteTree ()
{
	if ( this -> left )
		this -> left -> deleteTree ();
	if ( this -> right )
		this -> right -> deleteTree ();
	delete this;
}
void Tree :: InorderPrint ( )
{
	if ( this -> left )
		this -> left -> InorderPrint ( );
	cout << this -> info << ' ';
	if ( this -> right )
		this -> right -> InorderPrint ( );
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

unsigned int Tree :: branchCounter ( unsigned int count )
{
	if ( this -> left )
		count = this -> left -> branchCounter ( count );
	count ++;
	if ( this -> right )
		count = this -> right -> branchCounter ( count );
	return count;
}

Tree * Tree :: maxBalanced ( unsigned int & maxWeight )
{
	static Tree * pMaxBalanced ;
	int leftWeight = 0, rightWeight = 0, delta, currentWeight ;

	if ( this -> left )
		leftWeight = this -> left -> branchCounter ( 0 );
	if ( this -> right )
		rightWeight = this -> right -> branchCounter ( 0 );
	delta = leftWeight - rightWeight;
	currentWeight = leftWeight + rightWeight + 1;
	if ( delta <= 1 && delta >= -1 &&  currentWeight > maxWeight ) {
		maxWeight = currentWeight;
		pMaxBalanced = this;
	}

	if ( this -> left )
		 this -> left  -> maxBalanced ( maxWeight );
	if ( this -> right )
		 this -> right -> maxBalanced ( maxWeight );
	return pMaxBalanced;
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

void main  ()
{
	int arrInfo [ ] = { 	40,
				20, 60,
				10, 30, 50, 70,
				5, 15, 25, 35, 45, 55, 65, 75,
				13, 23, 27, 33, 37, 43, 59, 67,
				22, 24, 26, 32, 34, 36, 38, 44, 66, 68,
				21, 39, 69, STOP };
	Tree * begin = NULL;
	int i = 0;

	while ( arrInfo [ i ] != STOP )
		begin = begin -> additionElement ( arrInfo [ i ++ ] );

	unsigned int maxWeight = 0;
	Tree * maxBalancedNode = begin -> maxBalanced ( maxWeight );
	maxBalancedNode -> InorderPrint ( );

	begin -> deleteTree ();
}
